IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST04A.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
     SELECT GOZOUT ASSIGN TO "seqdata01.dat" 
            ORGANIZATION IS SEQUENTIAL 
            ACCESS       IS SEQUENTIAL
            FILE STATUS  IS FS.

DATA DIVISION.
FILE SECTION.

 FD  GOZOUT
     LABEL RECORD IS STANDARD.
 01  GOZOUT-REC.
     03 X-IND                         PIC  9(03).
     03 DESCRIPTION                   PIC  X(07).
      
WORKING-STORAGE SECTION.
 01  FS                              PIC  9(02).
 01  WS-COUNTER                      PIC  9(04) COMP-5.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE.
      PERFORM C000-MAIN-LOGIC 900 TIMES.
      PERFORM D000-CLEANUP.
      PERFORM E000-SUMMARY.
      STOP RUN.

B000-INITIALIZE.
      MOVE 1      TO WS-COUNTER.
      MOVE SPACES TO GOZOUT-REC.
      MOVE ALL 'Z' TO DESCRIPTION.
      OPEN OUTPUT GOZOUT.
      DISPLAY "SEQUENTIAL OUTPUT OPEN  STATUS " FS.

C000-MAIN-LOGIC.
      MOVE WS-COUNTER  TO X-IND.
      WRITE GOZOUT-REC.
*>      DISPLAY "SEQUENTIAL I/O WRITE STATUS " FS.
      ADD 1             TO WS-COUNTER.

D000-CLEANUP.
      CLOSE GOZOUT.
      DISPLAY "SEQUENTIAL OUTPUT CLOSE STATUS " FS.

E000-SUMMARY.
      SUBTRACT 1 FROM WS-COUNTER.
      DISPLAY "NUMBER OF RECORDS WRITTEN " WS-COUNTER.
