IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST04C.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
     SELECT GOZINOUT ASSIGN TO "seqdata01.dat" 
            ORGANIZATION IS SEQUENTIAL 
            ACCESS MODE     SEQUENTIAL
            FILE STATUS  IS FS.

DATA DIVISION.
FILE SECTION.

 FD  GOZINOUT
     LABEL RECORD IS STANDARD.
 01  GOZINOUT-REC.
     03 X-IND             PIC  9(03).
     03 DESCRIPTION       PIC  X(07).
      
WORKING-STORAGE SECTION.
 01  FS                   PIC  9(02).
 01  WS-COUNTER           PIC  9(04) COMP-5.
 01  WS-COUNTER-RW        PIC  9(04) COMP-5.
 01  WS-EOF-SW            PIC  X(01) VALUE 'N' .
   88  WS-EOF VALUE 'Y'.
 01  SELECTED-RECORDS     PIC 9(04).
   88 SELECTED-RECORD     VALUE 100, 200, 300, 400, 500, 600, 700.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE.
      PERFORM C000-MAIN-LOGIC UNTIL WS-EOF.
      PERFORM D000-CLEANUP.
      PERFORM E000-SUMMARY.
      STOP RUN.

B000-INITIALIZE.
      MOVE 0   TO WS-COUNTER WS-COUNTER-RW.
      OPEN I-O GOZINOUT.
      DISPLAY "SEQUENTIAL I/O OPEN STATUS " FS.

C000-MAIN-LOGIC.
      READ GOZINOUT
       AT END
         MOVE 'Y' TO WS-EOF-SW 
       NOT AT END
         ADD 1    TO WS-COUNTER
      END-READ.

      MOVE WS-COUNTER TO SELECTED-RECORDS.
      IF SELECTED-RECORD
      THEN
*>         DISPLAY "SEQUENTIAL I/O READ STATUS " FS
         MOVE 999 TO X-IND
         MOVE ALL "R" TO DESCRIPTION
         REWRITE GOZINOUT-REC
         DISPLAY "SEQUENTIAL I/O REWRITE STATUS " FS
         ADD 1    TO WS-COUNTER-RW
      END-IF.
            
D000-CLEANUP.
      CLOSE GOZINOUT.
      DISPLAY "SEQUENTIAL I/O CLOSE STATUS " FS.

E000-SUMMARY.
      DISPLAY "NUMBER OF RECORDS READ      " WS-COUNTER.
      DISPLAY "NUMBER OF RECORDS REWRITTEN " WS-COUNTER-RW.
