IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST06A.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
  SELECT GOZOUT ASSIGN TO "seqdata01.dat" 
         ORGANIZATION IS SEQUENTIAL 
         ACCESS       IS SEQUENTIAL
         FILE STATUS  IS FS.

DATA DIVISION.
FILE SECTION.

 FD  GOZOUT
     LABEL RECORD IS STANDARD.
 01 GOZOUT-REC-1.
     03 FILLER                       PIC  X(80).
 01 GOZOUT-REC-2.
     03 FILLER                       PIC  X(120).
 01 GOZOUT-REC-3.
     03 FILLER                       PIC  X(30).
 01 GOZOUT-REC-4                     PIC  X(50).
            
WORKING-STORAGE SECTION.
 01 FS                               PIC  9(02).
 01 WS-COUNTER                       PIC  9(04) COMP-5.
 01 WS-COUNTER-1                     PIC  9(04) COMP-5.
 01 WS-COUNTER-2                     PIC  9(04) COMP-5.
 01 WS-COUNTER-3                     PIC  9(04) COMP-5.
 01 WS-COUNTER-4                     PIC  9(04) COMP-5.
 01 WS-GOZOUT-REC-1.
     03 WS-X-IND-1                   PIC  9(03).
     03 WS-DESCRIPTION-1             PIC  X(10) VALUE ALL 'A'.
     03 FILLER                       PIC  X(67).
 01 WS-GOZOUT-REC-2.
     03 WS-X-IND-2                   PIC  9(03).
     03 WS-DESCRIPTION-2             PIC  X(10) VALUE ALL 'B'.
     03 FILLER                       PIC  X(107).
 01 WS-GOZOUT-REC-3.
     03 WS-X-IND-3                   PIC  9(03).
     03 WS-DESCRIPTION-3             PIC  X(10) VALUE ALL 'C'.
     03 FILLER                       PIC  X(17).
 01 WS-GOZOUT-REC-4.
     03 WS-X-IND-4                   PIC  9(03).
     03 WS-DESCRIPTION-4             PIC  X(10) VALUE ALL 'D'.
     03 FILLER                       PIC  X(37).

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE.
      PERFORM C000-MAIN-LOGIC 100 TIMES.
      PERFORM D000-CLEANUP.
      PERFORM E000-SUMMARY.
      STOP RUN.
      
B000-INITIALIZE.
      MOVE 1  TO WS-COUNTER.
      MOVE 0  TO WS-COUNTER-1
                 WS-COUNTER-2
                 WS-COUNTER-3
                 WS-COUNTER-4.
      MOVE SPACES TO GOZOUT-REC-2.

      MOVE ZEROS TO  WS-GOZOUT-REC-1
                     WS-GOZOUT-REC-2
                     WS-GOZOUT-REC-3
                     WS-GOZOUT-REC-4.

      MOVE ALL 'A' TO WS-DESCRIPTION-1.
      MOVE ALL 'B' TO WS-DESCRIPTION-2.
      MOVE ALL 'C' TO WS-DESCRIPTION-3.
      MOVE ALL 'D' TO WS-DESCRIPTION-4.

      OPEN OUTPUT GOZOUT.
      DISPLAY "SEQUENTIAL OUTPUT OPEN  STATUS " FS.

C000-MAIN-LOGIC.
      MOVE WS-COUNTER TO WS-X-IND-1.
      WRITE GOZOUT-REC-1 FROM WS-GOZOUT-REC-1.
      ADD 1           TO WS-COUNTER WS-COUNTER-1.

      MOVE WS-COUNTER TO WS-X-IND-2.
      WRITE GOZOUT-REC-2 FROM WS-GOZOUT-REC-2.
      ADD 1           TO WS-COUNTER WS-COUNTER-2.

      MOVE WS-COUNTER TO WS-X-IND-3.
      WRITE GOZOUT-REC-3 FROM WS-GOZOUT-REC-3.
      ADD 1           TO WS-COUNTER WS-COUNTER-3.

      MOVE WS-COUNTER TO WS-X-IND-4.
      WRITE GOZOUT-REC-4 FROM WS-GOZOUT-REC-4.
      ADD 1           TO WS-COUNTER WS-COUNTER-4.

D000-CLEANUP.
      CLOSE GOZOUT.
      DISPLAY "SEQUENTIAL OUTPUT CLOSE STATUS " FS .

E000-SUMMARY.
      SUBTRACT 1 FROM WS-COUNTER.
      DISPLAY "NUMBER OF RECORDS WRITTEN        " WS-COUNTER.
      DISPLAY "NUMBER OF RECORDS WRITTEN TYPE 1 " WS-COUNTER-1.
      DISPLAY "NUMBER OF RECORDS WRITTEN TYPE 2 " WS-COUNTER-2.
      DISPLAY "NUMBER OF RECORDS WRITTEN TYPE 3 " WS-COUNTER-3.
      DISPLAY "NUMBER OF RECORDS WRITTEN TYPE 4 " WS-COUNTER-4.
