IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST06C.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
     SELECT GOZINOUT ASSIGN TO "seqdata01.dat" 
            ORGANIZATION IS SEQUENTIAL 
            ACCESS MODE     SEQUENTIAL
            FILE STATUS  IS FS.

DATA DIVISION.
FILE SECTION.

 FD  GOZINOUT
     LABEL RECORD IS STANDARD.
 01 GOZINOUT-REC-1.
     03 FILLER                       PIC  X(80).
 01 GOZINOUT-REC-2.
     03 FILLER                       PIC  X(120).
 01 GOZINOUT-REC-3.
     03 FILLER                       PIC  X(30).
 01 GOZINOUT-REC-4                   PIC  X(50).
      
WORKING-STORAGE SECTION.
 01 FS                               PIC  9(02).
 01 WS-COUNTER                       PIC  9(04) COMP-5.
 01 WS-COUNTER-RW                    PIC  9(04) COMP-5.
 01 WS-COUNTER-RW-1                  PIC  9(04) COMP-5.
 01 WS-COUNTER-RW-2                  PIC  9(04) COMP-5.
 01 WS-COUNTER-RW-3                  PIC  9(04) COMP-5.
 01 WS-COUNTER-RW-4                  PIC  9(04) COMP-5.
 01 WS-EOF-SW                        PIC  X(01) VALUE 'N' .
   88  WS-EOF VALUE 'Y'.
 01  SELECTED-RECORDS                PIC 9(04).
   88 SELECTED-RECORD       VALUE 100, 200, 300, 101, 201, 301, 102, 202, 302, 103, 203, 303.
   88 SELECTED-RECORD-1     VALUE 100, 200, 300.
   88 SELECTED-RECORD-2     VALUE 101, 201, 301.
   88 SELECTED-RECORD-3     VALUE 102, 202, 302.
   88 SELECTED-RECORD-4     VALUE 103, 203, 303.
 01 WS-GOZINOUT-REC-1.
     03 WS-X-IND-1                   PIC  9(03).
     03 WS-DESCRIPTION-1             PIC  X(10).
     03 FILLER                       PIC  X(67).
 01 WS-GOZINOUT-REC-2.
     03 WS-X-IND-2                   PIC  9(03).
     03 WS-DESCRIPTION-2             PIC  X(10).
     03 FILLER                       PIC  X(107).
 01 WS-GOZINOUT-REC-3.
     03 WS-X-IND-3                   PIC  9(03).
     03 WS-DESCRIPTION-3             PIC  X(10).
     03 FILLER                       PIC  X(17).
 01 WS-GOZINOUT-REC-4.
     03 WS-X-IND-4                   PIC  9(03).
     03 WS-DESCRIPTION-4             PIC  X(10).
     03 FILLER                       PIC  X(37).

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE.
      PERFORM C000-MAIN-LOGIC UNTIL WS-EOF.
      PERFORM D000-CLEANUP.
      PERFORM E000-SUMMARY.
      STOP RUN.

B000-INITIALIZE.
      OPEN I-O GOZINOUT.
      DISPLAY "SEQUENTIAL I-O OPEN STATUS " FS.

C000-MAIN-LOGIC.
      READ GOZINOUT
       AT END
         MOVE 'Y' TO WS-EOF-SW 
       NOT AT END
         ADD 1   TO WS-COUNTER
         PERFORM C100-MAIN-LOGIC
      END-READ.

C100-MAIN-LOGIC.
      MOVE WS-COUNTER TO SELECTED-RECORDS.

      IF SELECTED-RECORD-1
      THEN
*>        DISPLAY "SEQUENTIAL I/O READ STATUS " FS
           MOVE GOZINOUT-REC-1 TO WS-GOZINOUT-REC-1
           MOVE 999 TO WS-X-IND-1
           MOVE ALL "R" TO WS-DESCRIPTION-1
           MOVE WS-GOZINOUT-REC-1 TO GOZINOUT-REC-1
           REWRITE GOZINOUT-REC-1
           DISPLAY "SEQUENTIAL I/O REWRITE STATUS " FS
           ADD 1    TO WS-COUNTER-RW-1
      END-IF.

      IF SELECTED-RECORD-2
      THEN
*>        DISPLAY "SEQUENTIAL I/O READ STATUS " FS
           MOVE GOZINOUT-REC-2 TO WS-GOZINOUT-REC-2
           MOVE 999 TO WS-X-IND-2
           MOVE ALL "R" TO WS-DESCRIPTION-2
           MOVE WS-GOZINOUT-REC-2 TO GOZINOUT-REC-2
           REWRITE GOZINOUT-REC-2
           DISPLAY "SEQUENTIAL I/O REWRITE STATUS " FS
           ADD 1    TO WS-COUNTER-RW-2
      END-IF.

      IF SELECTED-RECORD-3
      THEN
*>        DISPLAY "SEQUENTIAL I/O READ STATUS " FS
           MOVE GOZINOUT-REC-3 TO WS-GOZINOUT-REC-3
           MOVE 999 TO WS-X-IND-3
           MOVE ALL "R" TO WS-DESCRIPTION-3
           MOVE WS-GOZINOUT-REC-3 TO GOZINOUT-REC-3
           REWRITE GOZINOUT-REC-3
           DISPLAY "SEQUENTIAL I/O REWRITE STATUS " FS
           ADD 1    TO WS-COUNTER-RW-3
      END-IF.

      IF SELECTED-RECORD-4
      THEN
*>        DISPLAY "SEQUENTIAL I/O READ STATUS " FS
           MOVE GOZINOUT-REC-4 TO WS-GOZINOUT-REC-4
           MOVE 999 TO WS-X-IND-4
           MOVE ALL "R" TO WS-DESCRIPTION-4
           MOVE WS-GOZINOUT-REC-4 TO GOZINOUT-REC-4
           REWRITE GOZINOUT-REC-4
           DISPLAY "SEQUENTIAL I/O REWRITE STATUS " FS
           ADD 1    TO WS-COUNTER-RW-4
      END-IF.

D000-CLEANUP.
      CLOSE GOZINOUT.
      DISPLAY "SEQUENTIAL I-O CLOSE STATUS " FS.

E000-SUMMARY.
      ADD  WS-COUNTER-RW-1  
           WS-COUNTER-RW-2
           WS-COUNTER-RW-3
           WS-COUNTER-RW-4
           TO WS-COUNTER-RW.
      DISPLAY "NUMBER OF RECORDS READ             " WS-COUNTER.
      DISPLAY "NUMBER OF RECORDS REWRITTEN        " WS-COUNTER-RW.
      DISPLAY "NUMBER OF RECORDS REWRITTEN TYPE 1 " WS-COUNTER-RW-1.
      DISPLAY "NUMBER OF RECORDS REWRITTEN TYPE 2 " WS-COUNTER-RW-2.
      DISPLAY "NUMBER OF RECORDS REWRITTEN TYPE 3 " WS-COUNTER-RW-3.
      DISPLAY "NUMBER OF RECORDS REWRITTEN TYPE 4 " WS-COUNTER-RW-4.
