IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST06G.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
  SELECT GOZOUT ASSIGN TO "seqdata03.dat" 
         ORGANIZATION IS SEQUENTIAL 
         ACCESS       IS SEQUENTIAL
         FILE STATUS  IS FS.

DATA DIVISION.
FILE SECTION.

 FD  GOZOUT
*>     LABEL RECORD IS STANDARD
*>    RECORD CONTAINS 18 TO 75 CHARACTERS
     RECORD IS VARYING 18 TO 75 CHARACTERS.
 01 GOZOUT-REC-1.
     03 X-IND-1                      PIC  9(03).
     03 DESCRIPTION-1                PIC  X(10).
     03 BIN-IDX-1                    PIC  9(02).
     03 BIN-NUMBER-1                 PIC  X(03)
        OCCURS 1 TO 20 TIMES DEPENDING ON BIN-IDX-1.

WORKING-STORAGE SECTION.
 01 FS                               PIC  9(02).
 01 WS-COUNTER                       PIC  9(04) COMP-5.
 01 WS-COUNTER-1                     PIC  9(04) COMP-5.
 01 WS-COUNTER-2                     PIC  9(04) COMP-5.
 01 WS-COUNTER-3                     PIC  9(04) COMP-5.
 01 WS-COUNTER-4                     PIC  9(04) COMP-5.
 01 IDX                              PIC  9(02).

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE.
      PERFORM C000-MAIN-LOGIC 100 TIMES.
      PERFORM D000-CLEANUP.
      PERFORM E000-SUMMARY.
      STOP RUN.
      
B000-INITIALIZE.
      MOVE 1  TO WS-COUNTER.
      MOVE 0  TO WS-COUNTER-1
                 WS-COUNTER-2
                 WS-COUNTER-3
                 WS-COUNTER-4.
      PERFORM B020-INITIALIZE VARYING IDX 
          FROM 1 BY 1 UNTIL IDX EQUAL 20.
      OPEN OUTPUT GOZOUT.
      DISPLAY "SEQUENTIAL OUTPUT OPEN  STATUS " FS.

B020-INITIALIZE.
      MOVE IDX TO BIN-NUMBER-1 (IDX).

C000-MAIN-LOGIC.
      MOVE WS-COUNTER TO X-IND-1.
      MOVE ALL 'A' TO DESCRIPTION-1.
      MOVE 1 TO BIN-IDX-1.
      WRITE GOZOUT-REC-1.
      ADD 1  TO WS-COUNTER WS-COUNTER-1.

      MOVE WS-COUNTER TO X-IND-1.
      MOVE ALL 'B' TO DESCRIPTION-1.
      MOVE 3 TO BIN-IDX-1.
      WRITE GOZOUT-REC-1.
      ADD 1  TO WS-COUNTER WS-COUNTER-2.

      MOVE WS-COUNTER TO X-IND-1.
      MOVE ALL 'C' TO DESCRIPTION-1.
      MOVE 5 TO BIN-IDX-1.
      WRITE GOZOUT-REC-1.
      ADD 1  TO WS-COUNTER WS-COUNTER-3.

      MOVE WS-COUNTER TO X-IND-1.
      MOVE ALL 'D' TO DESCRIPTION-1.
      MOVE 11 TO BIN-IDX-1.
      WRITE GOZOUT-REC-1.
      ADD 1  TO WS-COUNTER WS-COUNTER-4.

D000-CLEANUP.
      CLOSE GOZOUT.
      DISPLAY "SEQUENTIAL OUTPUT CLOSE STATUS " FS .
 
E000-SUMMARY.
      SUBTRACT 1 FROM WS-COUNTER.
      DISPLAY "NUMBER OF RECORDS WRITTEN        " WS-COUNTER.
      DISPLAY "NUMBER OF RECORDS WRITTEN TYPE 1 " WS-COUNTER-1.
      DISPLAY "NUMBER OF RECORDS WRITTEN TYPE 2 " WS-COUNTER-2.
      DISPLAY "NUMBER OF RECORDS WRITTEN TYPE 3 " WS-COUNTER-3.
      DISPLAY "NUMBER OF RECORDS WRITTEN TYPE 4 " WS-COUNTER-4.
