IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST06H.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
     SELECT GOZIN ASSIGN TO "seqdata03.dat" 
            ORGANIZATION IS SEQUENTIAL 
            ACCESS MODE     SEQUENTIAL
            FILE STATUS  IS FS.

DATA DIVISION.
FILE SECTION.

 FD  GOZIN
*>     LABEL RECORD IS STANDARD
*>    RECORD CONTAINS 18 TO 75 CHARACTERS
     RECORD IS VARYING 18 TO 75 CHARACTERS.
 01 GOZOUT-REC-1.
     03 X-IND-1                      PIC  9(03).
     03 DESCRIPTION-1                PIC  X(10).
     03 BIN-IDX-1                    PIC  9(02).
     03 BIN-NUMBER-1                 PIC  X(03)
        OCCURS 1 TO 20 TIMES DEPENDING ON BIN-IDX-1.
      
WORKING-STORAGE SECTION.
 01 FS                               PIC  9(02).
 01 IDX                              PIC  9(02).
 01 WS-COUNTER                       PIC  9(04) COMP-5.
 01 WS-EOF-SW                        PIC  X(01) VALUE 'N' .
   88  WS-EOF VALUE 'Y'.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE.
      PERFORM C000-MAIN-LOGIC UNTIL WS-EOF.
      PERFORM D000-CLEANUP.
      PERFORM E000-SUMMARY.
      STOP RUN.

B000-INITIALIZE.
      OPEN INPUT GOZIN.
      DISPLAY "SEQUENTIAL INPUT OPEN STATUS " FS.

C000-MAIN-LOGIC.
     READ GOZIN
       AT END
         MOVE 'Y' TO WS-EOF-SW 
       NOT AT END
         ADD 1    TO WS-COUNTER
     END-READ.

D000-CLEANUP.
      CLOSE GOZIN.
      DISPLAY "SEQUENTIAL INPUT CLOSE STATUS " FS.

E000-SUMMARY.
      DISPLAY "NUMBER OF RECORDS READ " WS-COUNTER.

