IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST06J.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
     SELECT GOZINOUT ASSIGN TO "seqdata03.dat" 
            ORGANIZATION IS SEQUENTIAL 
            ACCESS MODE     SEQUENTIAL
            FILE STATUS  IS FS.

DATA DIVISION.
FILE SECTION.

 FD  GOZINOUT
*>     LABEL RECORD IS STANDARD
*>    RECORD CONTAINS 18 TO 75 CHARACTERS
     RECORD IS VARYING 18 TO 75 CHARACTERS.
 01 GOZINOUT-REC-1.
     03 X-IND-1                      PIC  9(03).
     03 DESCRIPTION-1                PIC  X(10).
     03 BIN-IDX-1                    PIC  9(02).
     03 BIN-NUMBER-1                 PIC  X(03)
        OCCURS 1 TO 20 TIMES DEPENDING ON BIN-IDX-1.
      
WORKING-STORAGE SECTION.
 01 FS                               PIC  9(02).
 01 IDX                              PIC  9(02).
 01 WS-COUNTER                       PIC  9(04) COMP-5.
 01 WS-COUNTER-RW                    PIC  9(04) COMP-5.
 01 WS-COUNTER-RW-1                  PIC  9(04) COMP-5.
 01 WS-COUNTER-RW-2                  PIC  9(04) COMP-5.
 01 WS-COUNTER-RW-3                  PIC  9(04) COMP-5.
 01 WS-COUNTER-RW-4                  PIC  9(04) COMP-5.
 01 WS-EOF-SW                        PIC  X(01) VALUE 'N' .
   88  WS-EOF VALUE 'Y'.
 01  SELECTED-RECORDS                PIC 9(04).
   88 SELECTED-RECORD       VALUE 100, 200, 300, 101, 201, 301, 102, 202, 302, 103, 203, 303.
   88 SELECTED-RECORD-1     VALUE 100, 200, 300.
   88 SELECTED-RECORD-2     VALUE 101, 201, 301.
   88 SELECTED-RECORD-3     VALUE 102, 202, 302.
   88 SELECTED-RECORD-4     VALUE 103, 203, 303.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE.
      PERFORM C000-MAIN-LOGIC UNTIL WS-EOF.
      PERFORM D000-CLEANUP.
      PERFORM E000-SUMMARY.
      STOP RUN.

B000-INITIALIZE.
      OPEN I-O GOZINOUT.
      DISPLAY "SEQUENTIAL I-O OPEN STATUS " FS.

C000-MAIN-LOGIC.
      READ GOZINOUT
       AT END
         MOVE 'Y' TO WS-EOF-SW 
       NOT AT END
         ADD 1    TO WS-COUNTER
         PERFORM C100-MAIN-LOGIC
      END-READ.

C100-MAIN-LOGIC.
      MOVE WS-COUNTER TO SELECTED-RECORDS.

      IF SELECTED-RECORD-1
      THEN
*>        DISPLAY "SEQUENTIAL I/O READ STATUS " FS
           MOVE 999 TO X-IND-1
           MOVE ALL "R" TO DESCRIPTION-1
           REWRITE GOZINOUT-REC-1
           DISPLAY "SEQUENTIAL I/O REWRITE STATUS " FS
           ADD 1    TO WS-COUNTER-RW-1
      END-IF.

      IF SELECTED-RECORD-2
      THEN
*>        DISPLAY "SEQUENTIAL I/O READ STATUS " FS
           MOVE 999 TO X-IND-1
           MOVE ALL "R" TO DESCRIPTION-1
           REWRITE GOZINOUT-REC-1
           DISPLAY "SEQUENTIAL I/O REWRITE STATUS " FS
           ADD 1    TO WS-COUNTER-RW-2
      END-IF.

      IF SELECTED-RECORD-3
      THEN
*>        DISPLAY "SEQUENTIAL I/O READ STATUS " FS
           MOVE 999 TO X-IND-1
           MOVE ALL "R" TO DESCRIPTION-1
           REWRITE GOZINOUT-REC-1
           DISPLAY "SEQUENTIAL I/O REWRITE STATUS " FS
           ADD 1    TO WS-COUNTER-RW-3
      END-IF.

      IF SELECTED-RECORD-4
      THEN
*>        DISPLAY "SEQUENTIAL I/O READ STATUS " FS
           MOVE 999 TO X-IND-1
           MOVE ALL "R" TO DESCRIPTION-1
           REWRITE GOZINOUT-REC-1
           DISPLAY "SEQUENTIAL I/O REWRITE STATUS " FS
           ADD 1    TO WS-COUNTER-RW-4
      END-IF.

D000-CLEANUP.
      CLOSE GOZINOUT.
      DISPLAY "SEQUENTIAL I-O CLOSE STATUS " FS.

E000-SUMMARY.
      ADD  WS-COUNTER-RW-1  
           WS-COUNTER-RW-2
           WS-COUNTER-RW-3
           WS-COUNTER-RW-4
           TO WS-COUNTER-RW.
      DISPLAY "NUMBER OF RECORDS READ             " WS-COUNTER.
      DISPLAY "NUMBER OF RECORDS REWRITTEN        " WS-COUNTER-RW.
      DISPLAY "NUMBER OF RECORDS REWRITTEN TYPE 1 " WS-COUNTER-RW-1.
      DISPLAY "NUMBER OF RECORDS REWRITTEN TYPE 2 " WS-COUNTER-RW-2.
      DISPLAY "NUMBER OF RECORDS REWRITTEN TYPE 3 " WS-COUNTER-RW-3.
      DISPLAY "NUMBER OF RECORDS REWRITTEN TYPE 4 " WS-COUNTER-RW-4.
