IDENTIFICATION DIVISION.
PROGRAM-ID. TEST10V.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
  SELECT ARQ ASSIGN TO "fileTEST10V.dat" 
      ORGANIZATION IS LINE SEQUENTIAL
      ACCESS MODE  IS SEQUENTIAL
      FILE STATUS  IS FS.

DATA DIVISION.
FILE SECTION.

 FD ARQ
*>   LABEL RECORD IS STANDARD
*>   RECORD IS VARYING IN SIZE FROM 10 TO 30 CHARACTERS
*>   DEPENDING ON RECORD-LENGTH
 .

 01 REG-ARQ-1.
   03 P-IND-1               PIC  9(03).
   03 DESCRIPTION-1         PIC  X(07).
 01 REG-ARQ-2.
   03 P-IND-2               PIC  9(03).
   03 DESCRIPTION-2         PIC  X(17).
 01 REG-ARQ-3.
   03 P-IND-3               PIC  9(03).
   03 DESCRIPTION-3         PIC  X(27).
 
WORKING-STORAGE SECTION.
 01 FS                       PIC 9(02).
*> 01 RECORD-LENGTH            PIC 9(03).         
 01 W-COUNTER                PIC 9(15).
 01 REM                      PIC 9(5).
 01 W01-SWITCHES             PIC X(03).
    88 W01-END VALUE "YES".
    88 W01-MORE VALUE "NO".
 01 WS-DESCRIPTIONS.
   03 WS-DESCRIPTION-1       PIC  X(07) VALUE ALL "AB".
   03 WS-DESCRIPTION-2       PIC  X(17) VALUE ALL "CD".
   03 WS-DESCRIPTION-3       PIC  X(27) VALUE ALL "EF".

PROCEDURE DIVISION.
MAIN SECTION.
     OPEN OUTPUT ARQ.
     IF FS > 0
     THEN
        DISPLAY "Error Creating File: " FS
        STOP RUN.
     MOVE 1 TO W-COUNTER.
     PERFORM WRITE-IT UNTIL W-COUNTER > 998.
     CLOSE ARQ.
     OPEN INPUT ARQ.
     IF FS > 0
     THEN
        DISPLAY "Error Opening File: " FS
        STOP RUN.
     MOVE "NO" TO W01-SWITCHES.
     PERFORM READ-IT UNTIL W01-END.
     CLOSE ARQ.
     STOP RUN.

WRITE-IT.
     MOVE W-COUNTER TO P-IND-1.
     MOVE WS-DESCRIPTION-1 TO DESCRIPTION-1.
     WRITE REG-ARQ-1.
     IF FS > 0
     THEN
        DISPLAY "Error Writing File: " FS
        STOP RUN.
     ADD 1 TO W-COUNTER.

     MOVE W-COUNTER TO P-IND-2.
     MOVE WS-DESCRIPTION-2 TO DESCRIPTION-2.
     WRITE REG-ARQ-2.
     IF FS > 0
     THEN
        DISPLAY "Error Writing File: " FS
        STOP RUN.
     ADD 1 TO W-COUNTER.

     MOVE W-COUNTER TO P-IND-3.
     MOVE WS-DESCRIPTION-3 TO DESCRIPTION-3.
     WRITE REG-ARQ-3.
     IF FS > 0
     THEN
        DISPLAY "Error Writing File: " FS
        STOP RUN.
     ADD 1 TO W-COUNTER.

READ-IT.
     READ ARQ 
        AT END 
           MOVE "YES" TO W01-SWITCHES
        NOT AT END 
           DISPLAY REG-ARQ-1
     END-READ.
 
