IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST12A.
ENVIRONMENT DIVISION.

*> Create indexed file using sequential write 

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
     ASSIGN TO "idxiotest01" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS SEQUENTIAL
     RECORD KEY IS TR-KEY
     ALTERNATE RECORD KEY IS TR-REC-TYPE 
       WITH DUPLICATES
     FILE STATUS IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
01  TEST-REC.
    05  TR-KEY                 PIC  9(03).
    05  TR-REC-TYPE            PIC  X(02).
    05  TR-DESCRIPTION         PIC  X(10).

WORKING-STORAGE SECTION.
 01  TR-FS                     PIC 9(02).
 01  WS-COUNTER                PIC 9(05) COMP-5.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
     PERFORM A000-INITIALIZE.
     PERFORM 9000-WRITE-IT 100 TIMES.
     PERFORM B000-HOUSEKEEPING.
     PERFORM Z000-SUMMARY.

     STOP RUN.

A000-INITIALIZE.
    MOVE ZERO TO WS-COUNTER.
    OPEN OUTPUT TEST-FILE.
    DISPLAY "INDEX WRITE OPEN STATUS  " TR-FS.

B000-HOUSEKEEPING.
    CLOSE TEST-FILE.
    DISPLAY "INDEX WRITE CLOSE STATUS " TR-FS.

9000-WRITE-IT.
    MOVE WS-COUNTER    TO TR-KEY.
    MOVE "RU"          TO TR-REC-TYPE.
    MOVE ALL "U"       TO TR-DESCRIPTION.

    IF WS-COUNTER = 10
       MOVE "S1"       TO TR-REC-TYPE
       MOVE ALL "A"    TO TR-DESCRIPTION.

    IF WS-COUNTER = 20
       MOVE "S2"       TO TR-REC-TYPE
       MOVE ALL "B"    TO TR-DESCRIPTION.

    IF WS-COUNTER = 30
       MOVE "S3"       TO TR-REC-TYPE
       MOVE ALL "C"    TO TR-DESCRIPTION.

    IF WS-COUNTER = 40
       MOVE "S4"       TO TR-REC-TYPE
       MOVE ALL "D"    TO TR-DESCRIPTION.

    IF WS-COUNTER = 50
       MOVE "S5"       TO TR-REC-TYPE
       MOVE ALL "E"    TO TR-DESCRIPTION.

    IF WS-COUNTER = 60
       MOVE "S6"       TO TR-REC-TYPE
       MOVE ALL "F"    TO TR-DESCRIPTION.

    IF WS-COUNTER = 70
       MOVE "S7"       TO TR-REC-TYPE
       MOVE ALL "G"    TO TR-DESCRIPTION.

    IF WS-COUNTER = 80
       MOVE "S8"       TO TR-REC-TYPE
       MOVE ALL "H"    TO TR-DESCRIPTION.

    IF WS-COUNTER = 90
       MOVE "S9"       TO TR-REC-TYPE
       MOVE ALL "I"    TO TR-DESCRIPTION.

    WRITE TEST-REC.

    ADD 1 TO WS-COUNTER.

Z000-SUMMARY.
    DISPLAY "NUMBER OF RECORDS WRITTEN " WS-COUNTER.
