IDENTIFICATION DIVISION.
PROGRAM-ID. TEST12B.
ENVIRONMENT DIVISION.

*> Indexed file sequential read

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "idxiotest01" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS SEQUENTIAL
     RECORD KEY   IS TR-KEY
     ALTERNATE RECORD KEY IS TR-REC-TYPE 
       WITH DUPLICATES
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
 01  TEST-REC.
   05  TR-KEY                 PIC  9(03).
   05  TR-REC-TYPE            PIC  X(02).
   05  TR-DESCRIPTION         PIC  X(10).

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 WS-COUNTER                 PIC 9(05) COMP-5.
 01 WS-SWITCHES-EOF            PIC X(01) VALUE 'N'.
   88 WS-EOF       VALUE 'Y'.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM 0000-LOOP.
   PERFORM B000-HOUSEKEEPING.
   PERFORM Z000-SUMMARY.

   STOP RUN.

0000-LOOP.
   PERFORM C000-PROCESS UNTIL WS-EOF.

A000-INITIALIZE.
   MOVE 0 TO WS-COUNTER.
   OPEN INPUT TEST-FILE.
   DISPLAY "INDEX READ OPEN STATUS  " TR-FS.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "INDEX READ CLOSE STATUS " TR-FS.

C000-PROCESS.
   READ TEST-FILE NEXT
    AT END
      MOVE 'Y' TO WS-SWITCHES-EOF
    NOT AT END
     ADD 1 TO WS-COUNTER
   END-READ.

Z000-SUMMARY.
    DISPLAY "NUMBER OF RECORDS READ " WS-COUNTER.
