IDENTIFICATION DIVISION.
PROGRAM-ID. TEST12F.
ENVIRONMENT DIVISION.

*> Indexed file start and read using primary key

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "idxiotest01" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS DYNAMIC
     RECORD KEY IS TR-KEY
     ALTERNATE RECORD KEY IS TR-REC-TYPE 
       WITH DUPLICATES
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
 01 TEST-REC.
   05 TR-KEY                   PIC  9(03).
   05 TR-REC-TYPE              PIC  X(02).
   05 TR-DESCRIPTION           PIC  X(10).

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 WS-COUNTER                 PIC 9(05) COMP-5.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM C000-MAIN-PROCESS.
   PERFORM B000-HOUSEKEEPING.
   PERFORM Z000-SUMMARY.

   STOP RUN.

A000-INITIALIZE.
   MOVE 0 TO WS-COUNTER.
   OPEN INPUT TEST-FILE.
   DISPLAY "INDEX INPUT OPEN STATUS  " TR-FS.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "INDEX INPUT CLOSE STATUS " TR-FS.

C000-MAIN-PROCESS.
   MOVE 98 TO TR-KEY.
   START TEST-FILE.
   DISPLAY "START KEY EQUAL " TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " TR-KEY " FILE STATUS " TR-FS.

*> FIXME: What is the correct START value 
   MOVE 9 TO TR-KEY.
   START TEST-FILE KEY IS NOT EQUAL TO TR-KEY.
   DISPLAY "START KEY NOT EQUAL " TR-KEY " FILE STATUS " TR-FS.

   MOVE 10 TO TR-KEY.
   START TEST-FILE KEY IS EQUAL TO TR-KEY.
   DISPLAY "START KEY EQUAL " TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " TR-KEY " FILE STATUS " TR-FS.

   MOVE 31 TO TR-KEY.
   START TEST-FILE KEY IS LESS THAN TR-KEY.
   DISPLAY "START KEY LESS THAN " TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " TR-KEY " FILE STATUS " TR-FS.

   MOVE 49 TO TR-KEY.
   START TEST-FILE KEY IS GREATER THAN TR-KEY.
   DISPLAY "START KEY GREATER THAN " TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " TR-KEY " FILE STATUS " TR-FS.

   MOVE 70 TO TR-KEY.
   START TEST-FILE KEY IS NOT LESS THAN TR-KEY.
   DISPLAY "START KEY NOT LESS " TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " TR-KEY " FILE STATUS " TR-FS.

   MOVE 90 TO TR-KEY.
   START TEST-FILE KEY IS NOT GREATER THAN TR-KEY.
   DISPLAY "START KEY NOT GREATER " TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " TR-KEY " FILE STATUS " TR-FS.

   MOVE 20 TO TR-KEY.
   START TEST-FILE KEY IS LESS THAN OR EQUAL TO TR-KEY.
   DISPLAY "START KEY LESS THAN OR EQUAL " TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " TR-KEY " FILE STATUS " TR-FS.

   MOVE 40 TO TR-KEY.
   START TEST-FILE KEY IS GREATER THAN OR EQUAL TO TR-KEY.
   DISPLAY "START KEY GREATER THAN OR EQUAL " TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " TR-KEY " FILE STATUS " TR-FS.

   MOVE 999 TO TR-KEY.
   START TEST-FILE KEY IS EQUAL TO TR-KEY.
   DISPLAY "START KEY EQUAL " TR-KEY " FILE STATUS " TR-FS.

D000-READ-NEXT.
   READ TEST-FILE NEXT
    NOT AT END
     ADD 1 TO WS-COUNTER
   END-READ.

Z000-SUMMARY.
   DISPLAY "NUMBER OF RECORDS READ      " WS-COUNTER.
