IDENTIFICATION DIVISION.
PROGRAM-ID. TEST12G.
ENVIRONMENT DIVISION.

*> Indexed file start and read using secondary key

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "idxiotest01" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS DYNAMIC
     RECORD KEY IS TR-KEY
     ALTERNATE RECORD KEY IS TR-REC-TYPE 
       WITH DUPLICATES
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
 01 TEST-REC.
   05 TR-KEY                   PIC  9(03).
   05 TR-REC-TYPE              PIC  X(02).
   05 TR-DESCRIPTION           PIC  X(10).

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 WS-COUNTER                 PIC 9(05) COMP-5.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM C000-MAIN-PROCESS.
   PERFORM B000-HOUSEKEEPING.
   PERFORM Z000-SUMMARY.

   STOP RUN.

A000-INITIALIZE.
   MOVE 0 TO WS-COUNTER.
   OPEN INPUT TEST-FILE.
   DISPLAY "INDEX INPUT OPEN STATUS  " TR-FS.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "INDEX INPUT CLOSE STATUS " TR-FS.

C000-MAIN-PROCESS.

   MOVE 'RU' TO TR-REC-TYPE.
   START TEST-FILE KEY IS EQUAL TO TR-REC-TYPE.
   DISPLAY "START SECONDARY KEY EQUAL " TR-REC-TYPE " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT SECONDARY KEY " TR-REC-TYPE " FILE STATUS " TR-FS.

*> FIXME: What is the correct START value 
   MOVE 'RU' TO TR-REC-TYPE.
   START TEST-FILE KEY IS NOT EQUAL TO TR-REC-TYPE.
   DISPLAY "START SECONDARY KEY NOT EQUAL " TR-REC-TYPE " FILE STATUS " TR-FS.

   MOVE 'S2' TO TR-REC-TYPE.
   START TEST-FILE KEY IS LESS THAN TR-REC-TYPE.
   DISPLAY "START SECONDARY KEY LESS THAN " TR-REC-TYPE " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT SECONDARY KEY " TR-REC-TYPE " FILE STATUS " TR-FS.

   MOVE 'S1' TO TR-REC-TYPE.
   START TEST-FILE KEY IS GREATER THAN TR-REC-TYPE.
   DISPLAY "START SECONDARY KEY GREATER THAN " TR-REC-TYPE " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT SECONDARY KEY " TR-REC-TYPE " FILE STATUS " TR-FS.

   MOVE 'S3' TO TR-REC-TYPE.
   START TEST-FILE KEY IS NOT LESS THAN TR-REC-TYPE.
   DISPLAY "START SECONDARY KEY NOT LESS " TR-REC-TYPE " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT SECONDARY KEY " TR-REC-TYPE " FILE STATUS " TR-FS.

   MOVE 'S4' TO TR-REC-TYPE.
   START TEST-FILE KEY IS NOT GREATER THAN TR-REC-TYPE.
   DISPLAY "START SECONDARY KEY NOT GREATER " TR-REC-TYPE " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT SECONDARY KEY " TR-REC-TYPE " FILE STATUS " TR-FS.

   MOVE 'S5' TO TR-REC-TYPE.
   START TEST-FILE KEY IS LESS THAN OR EQUAL TO TR-REC-TYPE.
   DISPLAY "START SECONDARY KEY LESS THAN OR EQUAL " TR-REC-TYPE " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT SECONDARY KEY " TR-REC-TYPE " FILE STATUS " TR-FS.

   MOVE 'S6' TO TR-REC-TYPE.
   START TEST-FILE KEY IS GREATER THAN OR EQUAL TO TR-REC-TYPE.
   DISPLAY "START SECONDARY KEY GREATER THAN OR EQUAL " TR-REC-TYPE " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT SECONDARY KEY " TR-REC-TYPE " FILE STATUS " TR-FS.

   MOVE 'ZZ' TO TR-REC-TYPE.
   START TEST-FILE KEY IS EQUAL TO TR-REC-TYPE.
   DISPLAY "START SECONDARY KEY EQUAL " TR-REC-TYPE " FILE STATUS " TR-FS.


D000-READ-NEXT.
   READ TEST-FILE NEXT
    NOT AT END
     ADD 1 TO WS-COUNTER
   END-READ.

Z000-SUMMARY.
   DISPLAY "NUMBER OF RECORDS READ      " WS-COUNTER.
