IDENTIFICATION DIVISION.
PROGRAM-ID. TEST12M.
ENVIRONMENT DIVISION.

*> Indexed sequential delete using primary key

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "idxiotest01" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS SEQUENTIAL
     RECORD KEY   IS TR-KEY
     ALTERNATE RECORD KEY IS TR-REC-TYPE 
       WITH DUPLICATES
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
 01  TEST-REC.
   05  TR-KEY                 PIC  9(03).
   05  TR-REC-TYPE            PIC  X(02).
   05  TR-DESCRIPTION         PIC  X(10).

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 WS-COUNTER                 PIC 9(05) COMP-5.
 01 WS-COUNTER-D               PIC 9(05) COMP-5.
 01 WS-SWITCHES-EOF            PIC X(01) VALUE 'N'.
   88 WS-EOF       VALUE 'Y'.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM 0000-LOOP.
   PERFORM B000-HOUSEKEEPING.
   PERFORM Z000-SUMMARY.

   STOP RUN.

0000-LOOP.
   PERFORM D000-READ.
   PERFORM C000-PROCESS UNTIL WS-EOF.

A000-INITIALIZE.
   MOVE 0 TO WS-COUNTER WS-COUNTER-D.
   OPEN I-O TEST-FILE.
   DISPLAY "INDEX I-O OPEN STATUS  " TR-FS.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "INDEX I-O CLOSE STATUS " TR-FS.

C000-PROCESS.

   IF TR-KEY = 45
   THEN
     DISPLAY "READ NEXT KEY " TR-KEY " FILE STATUS " TR-FS
     DELETE TEST-FILE
     DISPLAY "DELETE STATUS " TR-FS
     ADD 1 TO WS-COUNTER-D
   END-IF.

   PERFORM D000-READ.

D000-READ.
   READ TEST-FILE NEXT
    AT END
      MOVE 'Y' TO WS-SWITCHES-EOF
    NOT AT END
     ADD 1 TO WS-COUNTER
   END-READ.

Z000-SUMMARY.
   DISPLAY "NUMBER OF RECORDS READ      " WS-COUNTER.
   DISPLAY "NUMBER OF RECORDS DELETED   " WS-COUNTER-D.
