IDENTIFICATION DIVISION.
PROGRAM-ID. TEST18A06.
ENVIRONMENT DIVISION.

*> Relative file start and read

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "reliotest01.dat" 
     ORGANIZATION IS RELATIVE
     ACCESS MODE  IS DYNAMIC
     RECORD KEY   IS WS-TR-KEY
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
01 TEST-REC.
   05 FILLER                   PIC X(23).

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 WS-TR-KEY                  PIC 9(03).
 01 WS-COUNTER-REC             PIC 9(05) COMP-5.
 01 WS-TEST-REC.
   05 WS-TEST-REC-KEY          PIC X(03).
   05 FILLER                   PIC X(01).
   05 WS-TEST-REC-DESCRIPTION  PIC X(19).
 01 WS-EOF-IND                 PIC X(01) VALUE 'N'.
   88 WS-EOF-TRUE              VALUE 'Y'.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM C000-MAIN-PROCESS.
   PERFORM B000-HOUSEKEEPING.
   PERFORM Z000-SUMMARY.

   STOP RUN.

A000-INITIALIZE.
   OPEN INPUT TEST-FILE.
   DISPLAY "RELATIVE OPEN INPUT STATUS  " TR-FS.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RELATIVE CLOSE INPUT STATUS " TR-FS.

C000-MAIN-PROCESS.
   MOVE 4 TO WS-TR-KEY.
   START TEST-FILE.
   DISPLAY "START KEY EQUAL " WS-TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " WS-TR-KEY " FILE STATUS " TR-FS.

   MOVE 2 TO WS-TR-KEY.
   START TEST-FILE KEY IS NOT EQUAL TO WS-TR-KEY.
   DISPLAY "START KEY NOT EQUAL " WS-TR-KEY " FILE STATUS " TR-FS.

   MOVE 6 TO WS-TR-KEY.
   START TEST-FILE KEY IS EQUAL TO WS-TR-KEY.
   DISPLAY "START KEY EQUAL " WS-TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " WS-TR-KEY " FILE STATUS " TR-FS.

   MOVE 15 TO WS-TR-KEY.
   START TEST-FILE KEY IS LESS THAN WS-TR-KEY.
   DISPLAY "START KEY LESS THAN " WS-TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
*>   DISPLAY "READ NEXT KEY " WS-TR-KEY " FILE STATUS " TR-FS.
   DISPLAY "READ NEXT KEY " WS-TEST-REC-KEY " FILE STATUS " TR-FS.

   MOVE 18 TO WS-TR-KEY.
   START TEST-FILE KEY IS GREATER THAN WS-TR-KEY.
   DISPLAY "START KEY GREATER THAN " WS-TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " WS-TR-KEY " FILE STATUS " TR-FS.

   MOVE 25 TO WS-TR-KEY.
   START TEST-FILE KEY IS NOT LESS THAN WS-TR-KEY.
   DISPLAY "START KEY NOT LESS THAN " WS-TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " WS-TR-KEY " FILE STATUS " TR-FS.

   MOVE 29 TO WS-TR-KEY.
   START TEST-FILE KEY IS NOT GREATER THAN WS-TR-KEY.
   DISPLAY "START KEY NOT GREATER THAN " WS-TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " WS-TR-KEY " FILE STATUS " TR-FS.

   MOVE 35 TO WS-TR-KEY.
   START TEST-FILE KEY IS LESS THAN OR EQUAL TO WS-TR-KEY.
   DISPLAY "START KEY LESS THAN " WS-TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " WS-TR-KEY " FILE STATUS " TR-FS.

   MOVE 1 TO WS-TR-KEY.
   START TEST-FILE KEY IS GREATER THAN OR EQUAL TO WS-TR-KEY.
   DISPLAY "START KEY GREATER THAN OR EQUAL " WS-TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ NEXT KEY " WS-TR-KEY " FILE STATUS " TR-FS.

   MOVE 999 TO WS-TR-KEY.
   START TEST-FILE KEY IS EQUAL TO WS-TR-KEY.
   DISPLAY "START KEY EQUAL " WS-TR-KEY " FILE STATUS " TR-FS.

D000-READ-NEXT.
   READ TEST-FILE NEXT INTO WS-TEST-REC
    NOT AT END
     ADD 1 TO WS-COUNTER-REC
   END-READ.

Z000-SUMMARY.
    DISPLAY "NUMBER OF RECORDS READ " WS-COUNTER-REC.
