IDENTIFICATION DIVISION.
PROGRAM-ID. TEST18A10.
ENVIRONMENT DIVISION.

*> Relative file start read rewrite

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "reliotest01.dat" 
     ORGANIZATION IS RELATIVE
     ACCESS MODE  IS DYNAMIC
     RECORD KEY IS WS-TR-KEY
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
 01 TEST-REC.
   05 FILLER                   PIC X(23).

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 WS-TR-KEY                  PIC 9(03).
 01 WS-TEST-REC.
   05 WS-TEST-REC-KEY          PIC X(03).
   05 FILLER                   PIC X(01).
   05 WS-TEST-REC-DESCRIPTION  PIC X(19).
 01 WS-COUNTER-REC             PIC 9(05) COMP-5.
 01 WS-COUNTER-RW              PIC 9(05) COMP-5.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM C000-MAIN-PROCESS.
   PERFORM B000-HOUSEKEEPING.
   PERFORM Z000-SUMMARY.

   STOP RUN.

A000-INITIALIZE.
   MOVE 0 TO WS-COUNTER-REC WS-COUNTER-RW.
   OPEN I-O TEST-FILE.
   DISPLAY "RELATIVE OPEN I-O STATUS  " TR-FS.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RELATIVE CLOSE I-O STATUS " TR-FS.

C000-MAIN-PROCESS.
   MOVE 34 TO WS-TR-KEY.
   START TEST-FILE.
   DISPLAY "START KEY EQUAL " WS-TR-KEY " FILE STATUS " TR-FS.

   PERFORM D000-READ-NEXT.
   DISPLAY "READ KEY " WS-TR-KEY " FILE STATUS " TR-FS.

   MOVE ALL "R" TO WS-TEST-REC-DESCRIPTION.
   REWRITE TEST-REC FROM WS-TEST-REC.
   DISPLAY "REWRITE STATUS " TR-FS.
   ADD 1 TO WS-COUNTER-RW.

D000-READ-NEXT.
   READ TEST-FILE NEXT INTO WS-TEST-REC
     NOT AT END 
       ADD 1 TO WS-COUNTER-REC
   END-READ.

Z000-SUMMARY.
    DISPLAY "NUMBER OF RECORDS READ      " WS-COUNTER-REC.
    DISPLAY "NUMBER OF RECORDS REWRITTEN " WS-COUNTER-RW.
