IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST18B01.
ENVIRONMENT DIVISION.

*> Relative variable (format 1) sequential mode write::

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
  ASSIGN TO "reliotest21.dat" 
  ORGANIZATION IS RELATIVE
  ACCESS MODE  IS SEQUENTIAL
  RELATIVE KEY IS WS-TR-KEY
  FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
  LABEL RECORDS ARE STANDARD.

 01 TEST-REC-1.
   05 TR-KEY-1                 PIC X(03).
   05 FILLER                   PIC X(01).
   05 TR-DESCRIPTION-1         PIC X(09).

 01 TEST-REC-2.
   05 TR-KEY-2                 PIC X(03).
   05 FILLER                   PIC X(01).
   05 TR-DESCRIPTION-2         PIC X(19).

WORKING-STORAGE SECTION.
 01 WS-TR-KEY                  PIC 9(03).
 01 TR-FS                      PIC 9(02).
 01 WS-COUNTER                 PIC 9(03).
 01 WS-COUNTER-REC             PIC 9(05) COMP-5.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM 9000-WRITE-IT 5 TIMES.
   PERFORM B000-HOUSEKEEPING.
   PERFORM Z000-SUMMARY.

   STOP RUN.

A000-INITIALIZE.
   MOVE 0 TO WS-COUNTER-REC.
   MOVE 1 TO WS-COUNTER WS-TR-KEY.
   MOVE SPACES TO TEST-REC-2.
   OPEN OUTPUT TEST-FILE.
   DISPLAY "RELATIVE OPEN OUTPUT STATUS  " TR-FS.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RELATIVE CLOSE OUTPUT STATUS " TR-FS.

9000-WRITE-IT.
   MOVE SPACES TO TEST-REC-2.

   MOVE ZERO TO WS-TR-KEY.
   MOVE ALL 'A' TO TR-DESCRIPTION-1.
   MOVE WS-COUNTER TO TR-KEY-1.
   WRITE TEST-REC-1.

   ADD 1 TO WS-COUNTER WS-COUNTER-REC.

   MOVE ZERO TO WS-TR-KEY.
   MOVE ALL 'B' TO TR-DESCRIPTION-2.
   MOVE WS-COUNTER TO TR-KEY-2.
   WRITE TEST-REC-2.

   ADD 1 TO WS-COUNTER WS-COUNTER-REC.

Z000-SUMMARY.
    DISPLAY "NUMBER OF RECORDS WRITTEN " WS-COUNTER-REC.
