IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST18B03.
ENVIRONMENT DIVISION.

*> Relative variable (format 1) sequential read

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
  ASSIGN TO "reliotest21.dat" 
  ORGANIZATION IS RELATIVE
  ACCESS MODE  IS SEQUENTIAL
  RELATIVE KEY IS WS-TR-KEY
  FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.

 01 TEST-REC-1.
   05 TR-KEY-1                 PIC X(03).
   05 FILLER                   PIC X(01).
   05 TR-DESCRIPTION-1         PIC X(09).

 01 TEST-REC-2.
   05 TR-KEY-2                 PIC X(03).
   05 FILLER                   PIC X(01).
   05 TR-DESCRIPTION-2         PIC X(19).

WORKING-STORAGE SECTION.
 01 WS-TR-KEY                  PIC 9(03).
 01 TR-FS                      PIC 9(02).
 01 WS-COUNTER-REC             PIC 9(05) COMP-5.
 01 WS-EOF-IND                 PIC X(01) VALUE 'N'.
   88 WS-EOF-TRUE              VALUE 'Y'.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM 9000-READ-IT UNTIL WS-EOF-TRUE.
   PERFORM B000-HOUSEKEEPING.
   PERFORM Z000-SUMMARY.

   STOP RUN.

A000-INITIALIZE.
   OPEN INPUT TEST-FILE.
   DISPLAY "RELATIVE OPEN INPUT STATUS  " TR-FS.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RELATIVE CLOSE INPUT STATUS " TR-FS.

9000-READ-IT.
   MOVE '000' TO TR-KEY-1.
   READ TEST-FILE RECORD
     AT END 
       MOVE 'Y' TO WS-EOF-IND
     NOT AT END 
       ADD 1 TO WS-COUNTER-REC
   END-READ.

Z000-SUMMARY.
    DISPLAY "NUMBER OF RECORDS READ " WS-COUNTER-REC.
