IDENTIFICATION DIVISION.
PROGRAM-ID.    TEST18D02.
ENVIRONMENT DIVISION.

*> Relative variable (format 3) dynamic mode write

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
  ASSIGN TO "reliotest61.dat" 
  ORGANIZATION IS RELATIVE
  ACCESS MODE  IS DYNAMIC
  RELATIVE KEY IS WS-TR-KEY
  FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
 FD  TEST-FILE
*>     LABEL RECORD IS STANDARD
   RECORD IS VARYING 15 TO 72 CHARACTERS.

 01 TEST-REC-1.
   05 TR-KEY-1               PIC 9(03).
   05 FILLER                 PIC X(01).
   05 TR-DESCRIPTION-1       PIC X(06).
   05 TR-BIN-IDX-1           PIC 9(02).
   05 TR-BIN-NUMBER-1        PIC X(03)
      OCCURS 1 TO 20 TIMES DEPENDING ON TR-BIN-IDX-1.

WORKING-STORAGE SECTION.
 01 WS-TR-KEY                  PIC 9(03).
 01 TR-FS                      PIC 9(02).
 01 WS-COUNTER                 PIC 9(03).
 01 WS-COUNTER-REC             PIC 9(05) COMP-5.
 01 IDX                        PIC 9(03).

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM 9000-WRITE-IT 3 TIMES.
   PERFORM B000-HOUSEKEEPING.
   PERFORM Z000-SUMMARY.

   STOP RUN.

A000-INITIALIZE.
   MOVE SPACES    TO TEST-REC-1.
   MOVE 13        TO WS-COUNTER.
   MOVE WS-COUNTER TO WS-TR-KEY.
   PERFORM A020-INITIALIZE VARYING IDX 
      FROM 1 BY 1 UNTIL IDX EQUAL 21.

   OPEN I-O TEST-FILE.
   DISPLAY "RELATIVE OPEN I-O STATUS  " TR-FS.

A020-INITIALIZE.
    MOVE IDX TO TR-BIN-NUMBER-1 (IDX).

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RELATIVE CLOSE I-O STATUS " TR-FS.

9000-WRITE-IT.
   MOVE ALL 'D'   TO TR-DESCRIPTION-1.
   MOVE WS-COUNTER TO WS-TR-KEY TR-KEY-1.
   MOVE 18        TO TR-BIN-IDX-1

   WRITE TEST-REC-1.

   ADD 3 TO WS-COUNTER.
   ADD 1 TO WS-COUNTER-REC.

   MOVE ALL 'E'   TO TR-DESCRIPTION-1.
   MOVE WS-COUNTER TO WS-TR-KEY TR-KEY-1.
   MOVE 13        TO TR-BIN-IDX-1

   WRITE TEST-REC-1.

   ADD 3 TO WS-COUNTER.
   ADD 1 TO WS-COUNTER-REC.

   MOVE ALL 'F'   TO TR-DESCRIPTION-1.
   MOVE WS-COUNTER TO WS-TR-KEY TR-KEY-1.
   MOVE 3         TO TR-BIN-IDX-1

   WRITE TEST-REC-1.

   ADD 3 TO WS-COUNTER.
   ADD 1 TO WS-COUNTER-REC.

Z000-SUMMARY.
    DISPLAY "NUMBER OF RECORDS WRITTEN " WS-COUNTER-REC.
