IDENTIFICATION DIVISION.
PROGRAM-ID.    IDXIO01.
ENVIRONMENT DIVISION.

*> Create indexed file using sequential write 

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
     ASSIGN TO "idxiotest01" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS SEQUENTIAL
     RECORD KEY IS TR-KEY
     ALTERNATE RECORD KEY IS TR-REC-TYPE 
       WITH DUPLICATES
     FILE STATUS IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
01  TEST-REC.
    05  TR-KEY                 PIC  9(03).
    05  TR-REC-TYPE            PIC  X(02).
    05  TR-DESCRIPTION         PIC  X(10).


WORKING-STORAGE SECTION.
 01  TR-FS                     PIC 9(02).
 01  W-COUNTER                 PIC 9(15).

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
     PERFORM A000-INITIALIZE.

     PERFORM 9000-WRITE-IT 100 TIMES.
     PERFORM B000-HOUSEKEEPING.

     STOP RUN.

A000-INITIALIZE.
    MOVE ZERO TO W-COUNTER.
    OPEN OUTPUT TEST-FILE.
    DISPLAY "IXO1:(" TR-FS "):(00):INDEX WRITE OPEN".

B000-HOUSEKEEPING.
    CLOSE TEST-FILE.
    DISPLAY "IXC1:(" TR-FS "):(00):INDEX WRITE CLOSE".

9000-WRITE-IT.
    MOVE W-COUNTER     TO TR-KEY.
    MOVE "RU"          TO TR-REC-TYPE.
    MOVE ALL "U"       TO TR-DESCRIPTION.

    IF W-COUNTER = 10
       MOVE "S1"       TO TR-REC-TYPE
       MOVE ALL "A"    TO TR-DESCRIPTION.

    IF W-COUNTER = 20
       MOVE "S2"       TO TR-REC-TYPE
       MOVE ALL "B"    TO TR-DESCRIPTION.

    IF W-COUNTER = 30
       MOVE "S3"       TO TR-REC-TYPE
       MOVE ALL "C"    TO TR-DESCRIPTION.

    IF W-COUNTER = 40
       MOVE "S4"       TO TR-REC-TYPE
       MOVE ALL "D"    TO TR-DESCRIPTION.

    IF W-COUNTER = 50
       MOVE "S5"       TO TR-REC-TYPE
       MOVE ALL "E"    TO TR-DESCRIPTION.

    IF W-COUNTER = 60
       MOVE "S6"       TO TR-REC-TYPE
       MOVE ALL "F"    TO TR-DESCRIPTION.

    IF W-COUNTER = 70
       MOVE "S7"       TO TR-REC-TYPE
       MOVE ALL "G"    TO TR-DESCRIPTION.

    IF W-COUNTER = 80
       MOVE "S8"       TO TR-REC-TYPE
       MOVE ALL "H"    TO TR-DESCRIPTION.

    IF W-COUNTER = 90
       MOVE "S9"       TO TR-REC-TYPE
       MOVE ALL "I"    TO TR-DESCRIPTION.

    WRITE TEST-REC.
    IF TR-REC-TYPE <> "RU"
       DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE WRITE".

    ADD 1 TO W-COUNTER.
