IDENTIFICATION DIVISION.
PROGRAM-ID. IDXIO05.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "idxiotest01" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS DYNAMIC
     RECORD KEY IS TR-KEY
     ALTERNATE RECORD KEY IS TR-REC-TYPE 
       WITH DUPLICATES
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
 01 TEST-REC.
   05 TR-KEY                   PIC  9(03).
   05 TR-REC-TYPE              PIC  X(02).
   05 TR-DESCRIPTION           PIC  X(10).

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 W01-SWITCHES               PIC X(03).
   88 W01-END VALUE "YES".
   88 W01-MORE VALUE "NO".

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM C000-MAIN-PROCESS.
   PERFORM B000-HOUSEKEEPING.

   STOP RUN.

A000-INITIALIZE.
   OPEN I-O TEST-FILE.
   DISPLAY "IXO2:(" TR-FS "):(00):INDEX READ OPEN".
   MOVE "NO" TO W01-SWITCHES.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "IXC2:(" TR-FS "):(00):INDEX READ CLOSE".

C000-MAIN-PROCESS.
   MOVE 'RU' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(RU):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(000):INDEX FILE READ KEY".

   PERFORM D000-READ-NEXT.
   DISPLAY "IX24:(" TR-FS "):(00):INDEX FILE READ NEXT".
   DISPLAY "IX25:(" TR-REC-TYPE "):(RU):INDEX FILE READ NEXT".
   DISPLAY "IX26:(" TR-KEY "):(001):INDEX FILE READ NEXT".

   MOVE 'S1' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S1):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(010):INDEX FILE READ KEY".

   PERFORM D000-READ-PREV.
   DISPLAY "IX27:(" TR-FS "):(00):INDEX FILE READ PREVIOUS".
   DISPLAY "IX28:(" TR-REC-TYPE "):(RU):INDEX FILE READ PREVIOUS".
   DISPLAY "IX29:(" TR-KEY "):(099):INDEX FILE READ PREVIOUS".

   MOVE 'S2' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S2):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(020):INDEX FILE READ KEY".

   PERFORM D000-READ-NEXT.
   DISPLAY "IX24:(" TR-FS "):(00):INDEX FILE READ NEXT".
   DISPLAY "IX25:(" TR-REC-TYPE "):(S3):INDEX FILE READ NEXT".
   DISPLAY "IX26:(" TR-KEY "):(030):INDEX FILE READ NEXT".

   MOVE 'S3' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S3):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(030):INDEX FILE READ KEY".

   PERFORM D000-READ-PREV.
   DISPLAY "IX27:(" TR-FS "):(00):INDEX FILE READ PREVIOUS".
   DISPLAY "IX28:(" TR-REC-TYPE "):(S2):INDEX FILE READ PREVIOUS".
   DISPLAY "IX29:(" TR-KEY "):(020):INDEX FILE READ PREVIOUS".

   MOVE 'S4' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S4):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(040):INDEX FILE READ KEY".

   PERFORM D000-READ-NEXT.
   DISPLAY "IX24:(" TR-FS "):(00):INDEX FILE READ NEXT".
   DISPLAY "IX25:(" TR-REC-TYPE "):(S5):INDEX FILE READ NEXT".
   DISPLAY "IX26:(" TR-KEY "):(050):INDEX FILE READ NEXT".

   MOVE 'S5' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S5):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(050):INDEX FILE READ KEY".

   PERFORM D000-READ-PREV.
   DISPLAY "IX27:(" TR-FS "):(00):INDEX FILE READ PREVIOUS".
   DISPLAY "IX28:(" TR-REC-TYPE "):(S4):INDEX FILE READ PREVIOUS".
   DISPLAY "IX29:(" TR-KEY "):(040):INDEX FILE READ PREVIOUS".

   MOVE 'S6' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S6):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(060):INDEX FILE READ KEY".

   PERFORM D000-READ-NEXT.
   DISPLAY "IX24:(" TR-FS "):(00):INDEX FILE READ NEXT".
   DISPLAY "IX25:(" TR-REC-TYPE "):(S7):INDEX FILE READ NEXT".
   DISPLAY "IX26:(" TR-KEY "):(070):INDEX FILE READ NEXT".

   MOVE 'S7' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S7):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(070):INDEX FILE READ KEY".

   PERFORM D000-READ-PREV.
   DISPLAY "IX27:(" TR-FS "):(00):INDEX FILE READ PREVIOUS".
   DISPLAY "IX28:(" TR-REC-TYPE "):(S6):INDEX FILE READ PREVIOUS".
   DISPLAY "IX29:(" TR-KEY "):(060):INDEX FILE READ PREVIOUS".

   MOVE 'S8' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S8):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(080):INDEX FILE READ KEY".

   PERFORM D000-READ-NEXT.
   DISPLAY "IX24:(" TR-FS "):(00):INDEX FILE READ NEXT".
   DISPLAY "IX25:(" TR-REC-TYPE "):(S9):INDEX FILE READ NEXT".
   DISPLAY "IX26:(" TR-KEY "):(090):INDEX FILE READ NEXT".

   MOVE 'S9' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S9):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(090):INDEX FILE READ KEY".

   PERFORM D000-READ-PREV.
   DISPLAY "IX27:(" TR-FS "):(00):INDEX FILE READ PREVIOUS".
   DISPLAY "IX28:(" TR-REC-TYPE "):(S8):INDEX FILE READ PREVIOUS".
   DISPLAY "IX29:(" TR-KEY "):(080):INDEX FILE READ PREVIOUS".

   MOVE 'ZZ' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX01:(" TR-FS "):(23):INDEX FILE READ INVALID KEY".
   DISPLAY "IX02:(" TR-REC-TYPE "):(ZZ):INDEX FILE READ INVALID KEY".

   MOVE 'RU' TO TR-REC-TYPE.
   PERFORM D000-READ.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(RU):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(000):INDEX FILE READ KEY".
   PERFORM D000-READ-PREV.
   DISPLAY "IX01:(" TR-FS "):(10):INDEX FILE READ PREVIOUS AT EOF".


D000-READ.
   READ TEST-FILE 
     KEY IS TR-REC-TYPE
   END-READ.

D000-READ-NEXT.
   READ TEST-FILE NEXT
   END-READ.

D000-READ-PREV.
   READ TEST-FILE PREVIOUS
   END-READ.
