IDENTIFICATION DIVISION.
PROGRAM-ID. IDXIO06.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "idxiotest01" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS DYNAMIC
     RECORD KEY IS TR-KEY
     ALTERNATE RECORD KEY IS TR-REC-TYPE 
       WITH DUPLICATES
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
 01 TEST-REC.
   05 TR-KEY                   PIC  9(03).
   05 TR-REC-TYPE              PIC  X(02).
   05 TR-DESCRIPTION           PIC  X(10).

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 W01-SWITCHES               PIC X(03).
   88 W01-END VALUE "YES".
   88 W01-MORE VALUE "NO".

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM C000-MAIN-PROCESS.
   PERFORM B000-HOUSEKEEPING.

   STOP RUN.

A000-INITIALIZE.
   OPEN INPUT TEST-FILE.
   DISPLAY "IXO2:(" TR-FS "):(00):INDEX READ OPEN".
   MOVE "NO" TO W01-SWITCHES.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "IXC2:(" TR-FS "):(00):INDEX READ CLOSE".

C000-MAIN-PROCESS.
   MOVE 98 TO TR-KEY.
   START TEST-FILE.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY KEY EQUAL".
   DISPLAY "IX02:(" TR-KEY "):(098):INDEX FILE START KEY EQUAL".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(RU):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(098):INDEX FILE READ KEY".

*> FIXME: What is the correct START value 
   MOVE 9 TO TR-KEY.
   START TEST-FILE KEY IS NOT EQUAL TO TR-KEY.
   DISPLAY "IX01:(" TR-FS "):(99):INDEX FILE START WITH PRIMARY KEY NOT EQUAL".
   DISPLAY "IX02:(" TR-KEY "):(009):INDEX FILE READ KEY".

   MOVE 10 TO TR-KEY.
   START TEST-FILE KEY IS EQUAL TO TR-KEY.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY KEY EQUAL".
   DISPLAY "IX02:(" TR-KEY "):(010):INDEX FILE READ KEY".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S1):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(010):INDEX FILE READ KEY".

   MOVE 31 TO TR-KEY.
   START TEST-FILE KEY IS LESS THAN TR-KEY.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY LESS THAN".
   DISPLAY "IX02:(" TR-KEY "):(031):INDEX FILE START KEY LESS THAN".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S3):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(030):INDEX FILE READ KEY".

   MOVE 49 TO TR-KEY.
   START TEST-FILE KEY IS GREATER THAN TR-KEY.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY GREATER THAN".
   DISPLAY "IX02:(" TR-KEY "):(049):INDEX FILE START KEY GREATER THAN".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S5):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(050):INDEX FILE READ KEY".

   MOVE 70 TO TR-KEY.
   START TEST-FILE KEY IS NOT LESS THAN TR-KEY.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY NOT LESS THAN".
   DISPLAY "IX02:(" TR-KEY "):(070):INDEX FILE START KEY NOT LESS THAN".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S7):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(070):INDEX FILE READ KEY".

   MOVE 90 TO TR-KEY.
   START TEST-FILE KEY IS NOT GREATER THAN TR-KEY.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY NOT GREATER THAN".
   DISPLAY "IX02:(" TR-KEY "):(090):INDEX FILE START KEY PRIMARY NOT GREATER THAN".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S9):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(090):INDEX FILE READ KEY".

   MOVE 20 TO TR-KEY.
   START TEST-FILE KEY IS LESS THAN OR EQUAL TO TR-KEY.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMAY KEY LESS THAN OR EQUAL".
   DISPLAY "IX02:(" TR-KEY "):(020):INDEX FILE START KEY PRIMARY LESS THAN OR EQUAL".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S2):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(020):INDEX FILE READ KEY".

   MOVE 40 TO TR-KEY.
   START TEST-FILE KEY IS GREATER THAN OR EQUAL TO TR-KEY.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY GREATER THAN OR EQUAL ".
   DISPLAY "IX02:(" TR-KEY "):(040):INDEX FILE START KEY GREATER THAN OR EQUAL ".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE "):(S4):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY "):(040):INDEX FILE READ KEY".

   MOVE 999 TO TR-KEY.
   START TEST-FILE KEY IS EQUAL TO TR-KEY.
   DISPLAY "IX01:(" TR-FS "):(23):INDEX FILE START KEY EQUAL INVALID KEY".
   DISPLAY "IX02:(" TR-KEY "):(999):INDEX FILE START KEY EQUAL INVALID KEY ".

D000-READ-NEXT.
   READ TEST-FILE NEXT
   END-READ.
