IDENTIFICATION DIVISION.
PROGRAM-ID.    IDXIO21.
ENVIRONMENT DIVISION.

*> Create variable length indexed file using sequential write 

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
     ASSIGN TO "idxiotest21" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS SEQUENTIAL
     RECORD KEY IS TR-KEY-1
     ALTERNATE RECORD KEY IS TR-REC-TYPE-1
       WITH DUPLICATES
     FILE STATUS IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.

01  TEST-REC-1.
    05  TR-KEY-1               PIC  9(03).
    05  TR-REC-TYPE-1          PIC  X(02).
    05  TR-DESCRIPTION-1       PIC  X(05).

01  TEST-REC-2.
    05  TR-KEY-2               PIC  9(03).
    05  TR-REC-TYPE-2          PIC  X(02).
    05  TR-DESCRIPTION-2       PIC  X(10).


WORKING-STORAGE SECTION.
 01  TR-FS                     PIC 9(02).
 01  W-COUNTER                 PIC 9(05).
 01  W-COUNTER-VALUE           PIC 9(02).
    88 W-COUNTER-VALUES VALUES ARE 10, 20, 30, 40, 50, 60, 70, 80, 90.
    
PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
     PERFORM A000-INITIALIZE.

     PERFORM 9000-WRITE-IT 100 TIMES.
     PERFORM B000-HOUSEKEEPING.

     STOP RUN.

A000-INITIALIZE.
    MOVE ZERO TO W-COUNTER.
    OPEN OUTPUT TEST-FILE.
    DISPLAY "IXO1:(" TR-FS "):(00):INDEX WRITE OPEN".

B000-HOUSEKEEPING.
    CLOSE TEST-FILE.
    DISPLAY "IXC1:(" TR-FS "):(00):INDEX WRITE CLOSE".

9000-WRITE-IT.
    MOVE SPACES    TO TR-DESCRIPTION-2.
    MOVE W-COUNTER TO W-COUNTER-VALUE.
    IF W-COUNTER-VALUES
    THEN
       MOVE W-COUNTER     TO TR-KEY-2
       PERFORM 9100-WRITE-IT
    ELSE
       MOVE W-COUNTER     TO TR-KEY-1
       MOVE "RU"          TO TR-REC-TYPE-1
       MOVE ALL "U"       TO TR-DESCRIPTION-1
       WRITE TEST-REC-1
    END-IF.
    ADD 1 TO W-COUNTER.

9100-WRITE-IT.

    IF W-COUNTER = 10
       MOVE "S1"       TO TR-REC-TYPE-2
       MOVE ALL "A"    TO TR-DESCRIPTION-2.

    IF W-COUNTER = 20
       MOVE "S2"       TO TR-REC-TYPE-2
       MOVE ALL "B"    TO TR-DESCRIPTION-2.

    IF W-COUNTER = 30
       MOVE "S3"       TO TR-REC-TYPE-2
       MOVE ALL "C"    TO TR-DESCRIPTION-2.

    IF W-COUNTER = 40
       MOVE "S4"       TO TR-REC-TYPE-2
       MOVE ALL "D"    TO TR-DESCRIPTION-2.

    IF W-COUNTER = 50
       MOVE "S5"       TO TR-REC-TYPE-2
       MOVE ALL "E"    TO TR-DESCRIPTION-2.

    IF W-COUNTER = 60
       MOVE "S6"       TO TR-REC-TYPE-2
       MOVE ALL "F"    TO TR-DESCRIPTION-2.

    IF W-COUNTER = 70
       MOVE "S7"       TO TR-REC-TYPE-2
       MOVE ALL "G"    TO TR-DESCRIPTION-2.

    IF W-COUNTER = 80
       MOVE "S8"       TO TR-REC-TYPE-2
       MOVE ALL "H"    TO TR-DESCRIPTION-2.

    IF W-COUNTER = 90
       MOVE "S9"       TO TR-REC-TYPE-2
       MOVE ALL "I"    TO TR-DESCRIPTION-2.

    WRITE TEST-REC-2.
    
    DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE STATUS WRITE".
