IDENTIFICATION DIVISION.
PROGRAM-ID. IDXIO22.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "idxiotest21" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS SEQUENTIAL
     RECORD KEY   IS TR-KEY-1
     ALTERNATE RECORD KEY IS TR-REC-TYPE-1
       WITH DUPLICATES
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
 01 TEST-REC-1.
   05  TR-GKEY-1.
     10  TR-KEY-1              PIC  9(03).
   05  TR-REC-TYPE-1           PIC  X(02).
   05  TR-DESCRIPTION-1        PIC  X(05).

 01 TEST-REC-2.
   05  TR-KEY-2                PIC  9(03).
   05  TR-REC-TYPE-2           PIC  X(02).
   05  TR-DESCRIPTION-2        PIC  X(10).

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 W-COUNTER                  PIC 9(05).
 01 W01-SWITCHES               PIC X(03).
   88 W01-END VALUE "YES".
   88 W01-MORE VALUE "NO".

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM 0000-LOOP.
   PERFORM B000-HOUSEKEEPING.

   STOP RUN.

0000-LOOP.
   PERFORM D000-READ.
   PERFORM C000-PROCESS THRU C000-EXIT UNTIL W01-END.

A000-INITIALIZE.
   OPEN INPUT TEST-FILE.
   MOVE LOW-VALUES TO TR-GKEY-1.
   DISPLAY "ISO2:(" TR-FS "):(00):S/INDEX READ OPEN".
   MOVE "NO" TO W01-SWITCHES.
   MOVE 0 TO W-COUNTER.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "ISC2:(" TR-FS "):(00):S/INDEX READ CLOSE".

C000-PROCESS.

   IF TR-KEY-1 = 0
   THEN
      DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ"
      DISPLAY "IS22:(" TR-REC-TYPE-1 "):(RU):S/INDEX FILE READ"
      DISPLAY "IS23:(" TR-DESCRIPTION-1 "):(UUUUU):S/INDEX FILE READ"
   END-IF.

   IF TR-KEY-1 = 10
   THEN
      DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ" 
      DISPLAY "IS22:(" TR-REC-TYPE-2 "):(S1):S/INDEX FILE READ"
      DISPLAY "IS23:(" TR-DESCRIPTION-2 "):(AAAAAAAAAA):S/INDEX FILE DATA FROM READ"
   END-IF.

   IF TR-KEY-1 = 20
   THEN
      DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ"
      DISPLAY "IS22:(" TR-REC-TYPE-2 "):(S2):S/INDEX FILE READ"
      DISPLAY "IS23:(" TR-DESCRIPTION-2 "):(BBBBBBBBBB):S/INDEX FILE DATA FROM READ"
   END-IF.

   IF TR-KEY-1 = 30
   THEN
      DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ" 
      DISPLAY "IS22:(" TR-REC-TYPE-2 "):(S3):S/INDEX FILE READ"
      DISPLAY "IS23:(" TR-DESCRIPTION-2 "):(CCCCCCCCCC):S/INDEX FILE DATA FROM READ"
   END-IF.

   IF TR-KEY-1 = 40
   THEN
      DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ" 
      DISPLAY "IS22:(" TR-REC-TYPE-2 "):(S4):S/INDEX FILE READ"
      DISPLAY "IS23:(" TR-DESCRIPTION-2 "):(DDDDDDDDDD):S/INDEX FILE DATA FROM READ"
   END-IF.

   IF TR-KEY-1 = 50
   THEN
      DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ" 
      DISPLAY "IS22:(" TR-REC-TYPE-2 "):(S5):S/INDEX FILE READ"
      DISPLAY "IS23:(" TR-DESCRIPTION-2 "):(EEEEEEEEEE):S/INDEX FILE DATA FROM READ"
   END-IF.

   IF TR-KEY-1 = 60
   THEN
   DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ" 
   DISPLAY "IS22:(" TR-REC-TYPE-2 "):(S6):S/INDEX FILE READ"
   DISPLAY "IS23:(" TR-DESCRIPTION-2 "):(FFFFFFFFFF):S/INDEX FILE DATA FROM READ"
   END-IF.

   IF TR-KEY-1 = 70
   THEN
   DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ" 
   DISPLAY "IS22:(" TR-REC-TYPE-2 "):(S7):S/INDEX FILE READ"
   DISPLAY "IS23:(" TR-DESCRIPTION-2 "):(GGGGGGGGGG):S/INDEX FILE DATA FROM READ"
   END-IF.

   IF TR-KEY-1 = 80
   THEN
   DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ" 
   DISPLAY "IS22:(" TR-REC-TYPE-2 "):(S8):S/INDEX FILE READ"
   DISPLAY "IS23:(" TR-DESCRIPTION-2 "):(HHHHHHHHHH):S/INDEX FILE DATA FROM READ"
   END-IF.

   IF TR-KEY-1 = 90
   THEN
   DISPLAY "IS21:(" TR-FS "):(00):S/INDEX FILE STATUS READ" 
   DISPLAY "IS22:(" TR-REC-TYPE-2 "):(S9):S/INDEX FILE READ"
   DISPLAY "IS23:(" TR-DESCRIPTION-2 "):(IIIIIIIIII):S/INDEX FILE DATA FROM READ"
   END-IF.

   PERFORM D000-READ.

C000-EXIT.
   EXIT.

D000-READ.

   READ TEST-FILE NEXT
    AT END
      DISPLAY "IX10:(" TR-FS "):(10):INDEX FILE READ AT EOF"
      MOVE "YES" TO W01-SWITCHES
   END-READ.
