IDENTIFICATION DIVISION.
PROGRAM-ID. IDXIO26.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "idxiotest61" 
     ORGANIZATION IS INDEXED
     ACCESS MODE  IS DYNAMIC
     RECORD KEY IS TR-KEY-1
     ALTERNATE RECORD KEY IS TR-REC-TYPE-1 
       WITH DUPLICATES
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
*>     LABEL RECORD IS STANDARD
     RECORD IS VARYING 15 TO 72 CHARACTERS.

01 TEST-REC-1.
    05  TR-KEY-1               PIC  9(03).
    05  TR-REC-TYPE-1          PIC  X(02).
    05  TR-DESCRIPTION-1       PIC  X(05).
    05  TR-BIN-IDX-1           PIC  9(02).
    05  TR-BIN-NUMBER-1        PIC  X(03)
       OCCURS 1 TO 20 TIMES DEPENDING ON TR-BIN-IDX-1.

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 W01-SWITCHES               PIC X(03).
   88 W01-END VALUE "YES".
   88 W01-MORE VALUE "NO".

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM C000-MAIN-PROCESS.
   PERFORM B000-HOUSEKEEPING.

   STOP RUN.

A000-INITIALIZE.
   OPEN INPUT TEST-FILE.
   DISPLAY "IXO2:(" TR-FS "):(00):INDEX READ OPEN".
   MOVE "NO" TO W01-SWITCHES.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "IXC2:(" TR-FS "):(00):INDEX READ CLOSE".

C000-MAIN-PROCESS.
   MOVE 98 TO TR-KEY-1.
   START TEST-FILE.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY KEY EQUAL".
   DISPLAY "IX02:(" TR-KEY-1 "):(098):INDEX FILE START KEY EQUAL".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE-1 "):(RU):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY-1 "):(098):INDEX FILE READ KEY".
   DISPLAY "IS24:(" TR-BIN-IDX-1 "):(20):INDEX FILE READ BIN IDX"

*> FIXME: What is the correct START value 
   MOVE 9 TO TR-KEY-1.
   START TEST-FILE KEY IS NOT EQUAL TO TR-KEY-1.
   DISPLAY "IX01:(" TR-FS "):(99):INDEX FILE START WITH PRIMARY KEY NOT EQUAL".
   DISPLAY "IX02:(" TR-KEY-1 "):(009):INDEX FILE READ KEY".

   MOVE 10 TO TR-KEY-1.
   START TEST-FILE KEY IS EQUAL TO TR-KEY-1.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY KEY EQUAL".
   DISPLAY "IX02:(" TR-KEY-1 "):(010):INDEX FILE READ KEY".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE-1 "):(S1):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY-1 "):(010):INDEX FILE READ KEY".
   DISPLAY "IS24:(" TR-BIN-IDX-1 "):(01):INDEX FILE READ BIN IDX"

   MOVE 31 TO TR-KEY-1.
   START TEST-FILE KEY IS LESS THAN TR-KEY-1.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY LESS THAN".
   DISPLAY "IX02:(" TR-KEY-1 "):(031):INDEX FILE START KEY LESS THAN".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE-1 "):(S3):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY-1 "):(030):INDEX FILE READ KEY".
   DISPLAY "IS24:(" TR-BIN-IDX-1 "):(03):INDEX FILE READ BIN IDX"

   MOVE 49 TO TR-KEY-1.
   START TEST-FILE KEY IS GREATER THAN TR-KEY-1.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY GREATER THAN".
   DISPLAY "IX02:(" TR-KEY-1 "):(049):INDEX FILE START KEY GREATER THAN".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE-1 "):(S5):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY-1 "):(050):INDEX FILE READ KEY".
   DISPLAY "IS24:(" TR-BIN-IDX-1 "):(05):INDEX FILE READ BIN IDX"

   MOVE 70 TO TR-KEY-1.
   START TEST-FILE KEY IS NOT LESS THAN TR-KEY-1.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY NOT LESS THAN".
   DISPLAY "IX02:(" TR-KEY-1 "):(070):INDEX FILE START KEY NOT LESS THAN".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE-1 "):(S7):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY-1 "):(070):INDEX FILE READ KEY".
   DISPLAY "IS24:(" TR-BIN-IDX-1 "):(07):INDEX FILE READ BIN IDX"

   MOVE 90 TO TR-KEY-1.
   START TEST-FILE KEY IS NOT GREATER THAN TR-KEY-1.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY NOT GREATER THAN".
   DISPLAY "IX02:(" TR-KEY-1 "):(090):INDEX FILE START KEY PRIMARY NOT GREATER THAN".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE-1 "):(S9):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY-1 "):(090):INDEX FILE READ KEY".
   DISPLAY "IS24:(" TR-BIN-IDX-1 "):(09):INDEX FILE READ BIN IDX"

   MOVE 20 TO TR-KEY-1.
   START TEST-FILE KEY IS LESS THAN OR EQUAL TO TR-KEY-1.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMAY KEY LESS THAN OR EQUAL".
   DISPLAY "IX02:(" TR-KEY-1 "):(020):INDEX FILE START KEY PRIMARY LESS THAN OR EQUAL".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE-1 "):(S2):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY-1 "):(020):INDEX FILE READ KEY".
*> This is to avoid a BUG with VB-ISAM variable length records
   DISPLAY "IS24:(" TR-BIN-IDX-1 "):(12):INDEX FILE READ BIN IDX"

   MOVE 40 TO TR-KEY-1.
   START TEST-FILE KEY IS GREATER THAN OR EQUAL TO TR-KEY-1.
   DISPLAY "IX01:(" TR-FS "):(00):INDEX FILE START WITH PRIMARY GREATER THAN OR EQUAL ".
   DISPLAY "IX02:(" TR-KEY-1 "):(040):INDEX FILE START KEY GREATER THAN OR EQUAL ".
   PERFORM D000-READ-NEXT.
   DISPLAY "IX21:(" TR-FS "):(00):INDEX FILE READ KEY".
   DISPLAY "IX22:(" TR-REC-TYPE-1 "):(S4):INDEX FILE READ KEY".
   DISPLAY "IX23:(" TR-KEY-1 "):(040):INDEX FILE READ KEY".
   DISPLAY "IS24:(" TR-BIN-IDX-1 "):(04):INDEX FILE READ BIN IDX"

   MOVE 999 TO TR-KEY-1.
   START TEST-FILE KEY IS EQUAL TO TR-KEY-1.
   DISPLAY "IX01:(" TR-FS "):(23):INDEX FILE START KEY EQUAL INVALID KEY".
   DISPLAY "IX02:(" TR-KEY-1 "):(999):INDEX FILE START KEY EQUAL INVALID KEY ".

D000-READ-NEXT.
   READ TEST-FILE NEXT
   END-READ.
