 IDENTIFICATION DIVISION.
 PROGRAM-ID.    SEQLS11.
 ENVIRONMENT DIVISION.

 CONFIGURATION SECTION. 
 SPECIAL-NAMES.
     DECIMAL-POINT IS COMMA.
 INPUT-OUTPUT SECTION.
 FILE-CONTROL.
  SELECT GOZOUT ASSIGN TO "lineseq11.dat" 
         ORGANIZATION IS LINE SEQUENTIAL 
         ACCESS       IS SEQUENTIAL
         FILE STATUS  IS FS.

 DATA DIVISION.
 FILE SECTION.

 FD  GOZOUT
     LABEL RECORD IS STANDARD.
 01 GOZOUT-REC-1.
     03 FILLER                       PIC  X(80).
 01 GOZOUT-REC-2.
     03 FILLER                       PIC  X(120).
 01 GOZOUT-REC-3.
     03 FILLER                       PIC  X(30).
 01 GOZOUT-REC-4                     PIC  X(50).
            
 WORKING-STORAGE SECTION.
 01 FS                               PIC  9(02).
 01 WS-COUNTERS.
     05 WS-TEST-COUNTER              PIC  9(4).
 01 WS-GOZOUT-REC-1.
     03 WS-X-IND-1                   PIC  9(03).
     03 WS-DESCRIPTION-1             PIC  X(10) VALUE ALL 'A'.
     03 FILLER                       PIC  X(67).
 01 WS-GOZOUT-REC-2.
     03 WS-X-IND-2                   PIC  9(03).
     03 WS-DESCRIPTION-2             PIC  X(10) VALUE ALL 'B'.
     03 FILLER                       PIC  X(107).
 01 WS-GOZOUT-REC-3.
     03 WS-X-IND-3                   PIC  9(03).
     03 WS-DESCRIPTION-3             PIC  X(10) VALUE ALL 'C'.
     03 FILLER                       PIC  X(17).
 01 WS-GOZOUT-REC-4.
     03 WS-X-IND-4                   PIC  9(03).
     03 WS-DESCRIPTION-4             PIC  X(10) VALUE ALL 'D'.
     03 FILLER                       PIC  X(37).

 PROCEDURE DIVISION.
 0000-PROGRAM-ENTRY.
      MOVE 0              TO WS-TEST-COUNTER.
      PERFORM B000-INITIALIZE THRU B000-EXIT.
      PERFORM C000-MAIN-LOGIC THRU C000-EXIT.
      PERFORM D000-CLEANUP THRU D000-EXIT.
      PERFORM E000-SUMMARY THRU E000-EXIT.
      STOP RUN.
      
      DISPLAY "SQ06:(IL):(FA):PROGRAM RAN PAST STOP RUN".

 0000-EXIT.
      EXIT.
 
 B000-INITIALIZE.
      OPEN OUTPUT GOZOUT.
      ADD 1             TO WS-TEST-COUNTER.
      DISPLAY "SO11:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT OPEN STATUS".
 B000-EXIT.
      EXIT.

 C000-MAIN-LOGIC.
      MOVE SPACES TO GOZOUT-REC-2.
      MOVE ZEROS TO  WS-GOZOUT-REC-1
                     WS-GOZOUT-REC-2
                     WS-GOZOUT-REC-3
                     WS-GOZOUT-REC-4.
      MOVE ALL 'A' TO WS-DESCRIPTION-1.
      MOVE ALL 'B' TO WS-DESCRIPTION-2.
      MOVE ALL 'C' TO WS-DESCRIPTION-3.
      MOVE ALL 'D' TO WS-DESCRIPTION-4.

      MOVE 001 TO WS-X-IND-1.
      WRITE GOZOUT-REC-1 FROM WS-GOZOUT-REC-1.
      DISPLAY "SW11:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT WRITE STATUS".

      ADD 1             TO WS-TEST-COUNTER.

      MOVE 002 TO WS-X-IND-2.
      WRITE GOZOUT-REC-2 FROM WS-GOZOUT-REC-2.
      DISPLAY "SW11:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT WRITE STATUS".

      ADD 1             TO WS-TEST-COUNTER.

      MOVE 003 TO WS-X-IND-3.
      WRITE GOZOUT-REC-3 FROM WS-GOZOUT-REC-3.
      DISPLAY "SW11:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT WRITE STATUS".

      ADD 1             TO WS-TEST-COUNTER.

      MOVE 004 TO WS-X-IND-4.
      WRITE GOZOUT-REC-4 FROM WS-GOZOUT-REC-4.
      DISPLAY "SW11:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT WRITE STATUS".

      ADD 1             TO WS-TEST-COUNTER.

 C000-EXIT.
      EXIT.

 D000-CLEANUP.
      CLOSE GOZOUT.
      DISPLAY "SC11:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT CLOSE STATUS".
      ADD 1             TO WS-TEST-COUNTER.
 D000-EXIT.
      EXIT.
 
 E000-SUMMARY.
      DISPLAY "SQ04:(" WS-TEST-COUNTER "):(0006):"
          "TEST COUNT VALIDATION".
 E000-EXIT.
      EXIT. 
