 IDENTIFICATION DIVISION.
 PROGRAM-ID.    SEQLS17.
 ENVIRONMENT DIVISION.

 CONFIGURATION SECTION. 
 SPECIAL-NAMES.
     DECIMAL-POINT IS COMMA.
 INPUT-OUTPUT SECTION.
 FILE-CONTROL.
     SELECT GOZIN ASSIGN TO "lineseq15.dat" 
            ORGANIZATION IS LINE SEQUENTIAL 
            ACCESS MODE     SEQUENTIAL
            FILE STATUS  IS FS.

 DATA DIVISION.
 FILE SECTION.

 FD  GOZIN
*>     LABEL RECORD IS STANDARD
     RECORD IS VARYING IN SIZE FROM 30 TO 120 CHARACTERS
     DEPENDING ON RECORD-LENGTH.
 01 GOZOUT-REC-1.
     03 FILLER                        PIC  X(80).
 01 GOZOUT-REC-2.
     03 FILLER                        PIC  X(120).
 01 GOZOUT-REC-3.
     03 FILLER                        PIC  X(30).
 01 GOZOUT-REC-4                      PIC  X(50).
      
 WORKING-STORAGE SECTION.
 01 FS                               PIC  9(02).
 01 RECORD-LENGTH                    PIC 999.         
*> 01 RECORD-LENGTH                   PIC 9(4) COMP-5.         
 01 WS-GOZIN-REC-1.
     03 WS-X-IND-1                   PIC  9(03).
     03 WS-DESCRIPTION-1             PIC  X(10).

 PROCEDURE DIVISION.
 0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE THRU B000-EXIT.
      PERFORM C000-MAIN-LOGIC THRU C000-EXIT.
      PERFORM D000-CLEANUP THRU D000-EXIT.
      STOP RUN.

 B000-INITIALIZE.
      OPEN INPUT GOZIN.
      DISPLAY "SO17:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT OPEN STATUS".
 B000-EXIT.
     EXIT.

 C000-MAIN-LOGIC.
      READ GOZIN.
      MOVE GOZOUT-REC-1 TO WS-GOZIN-REC-1.
      DISPLAY "SR02:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT READ STATUS".
      DISPLAY "SR03:(" WS-X-IND-1 "):(001):"
          "DATA FROM READ".
      DISPLAY "SR03:(" WS-DESCRIPTION-1 "):(AAAAAAAAAA):"
          "DATA FROM READ".
      DISPLAY "SR03:(" RECORD-LENGTH "):(080):"
          "RECORD LENGTH FROM READ".

      READ GOZIN.
      MOVE GOZOUT-REC-2 TO WS-GOZIN-REC-1.
      DISPLAY "SR02:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT STATUS".
      DISPLAY "SR03:(" WS-X-IND-1 "):(002):"
          "DATA FROM READ".
      DISPLAY "SR03:(" WS-DESCRIPTION-1 "):(BBBBBBBBBB):"
          "DATA FROM READ".
      DISPLAY "SR03:(" RECORD-LENGTH "):(120):"
          "RECORD LENGTH FROM READ".

      READ GOZIN.
      MOVE GOZOUT-REC-3 TO WS-GOZIN-REC-1.
      DISPLAY "SR02:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT STATUS".
      DISPLAY "SR03:(" WS-X-IND-1 "):(003):"
          "DATA FROM READ".
      DISPLAY "SR03:(" WS-DESCRIPTION-1 "):(CCCCCCCCCC):"
          "DATA FROM READ".
      DISPLAY "SR03:(" RECORD-LENGTH "):(030):"
          "RECORD LENGTH FROM READ".

      READ GOZIN.
      MOVE GOZOUT-REC-4 TO WS-GOZIN-REC-1.
      DISPLAY "SR02:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT STATUS".
      DISPLAY "SR03:(" WS-X-IND-1 "):(004):"
          "DATA FROM READ".
      DISPLAY "SR03:(" WS-DESCRIPTION-1 "):(DDDDDDDDDD):"
          "DATA FROM READ".
      DISPLAY "SR03:(" RECORD-LENGTH "):(050):"
          "RECORD LENGTH FROM READ".

 C000-EXIT.
      EXIT.

 D000-CLEANUP.
      CLOSE GOZIN.
      DISPLAY "SC17:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT CLOSE STATUS".

 D000-EXIT.
     EXIT.  
