IDENTIFICATION DIVISION.
PROGRAM-ID.    RELIO04.
ENVIRONMENT DIVISION.
*> Program to read relative records using RANDOM access mode.

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
  ASSIGN TO "reliotest01.dat" 
  ORGANIZATION IS RELATIVE
  ACCESS MODE  IS DYNAMIC
  RELATIVE KEY IS WS-TR-KEY
  FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.
01  TEST-REC.
   05 FILLER                   PIC X(23).

WORKING-STORAGE SECTION.
 01 WS-TR-KEY                  PIC 9(03).
 01 TR-FS                      PIC 9(02).
 01 WS-TEST-REC.
   05 WS-TEST-REC-KEY          PIC X(03).
   05 FILLER                   PIC X(01) VALUE SPACES.
   05 WS-TEST-REC-DESCRIPTION  PIC X(19) VALUE ALL 'C'.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.

   PERFORM C000-PROCESS.

   PERFORM B000-HOUSEKEEPING.

   STOP RUN.

A000-INITIALIZE.
   OPEN INPUT TEST-FILE.
   DISPLAY "RLO4:(" TR-FS "):(00):RELATIVE RANDOM INPUT OPEN STATUS".

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RLC4:(" TR-FS "):(00):RELATIVE RANDOM INPUT CLOSE STATUS".

C000-PROCESS.

   MOVE 6 TO WS-TR-KEY.
   PERFORM 9000-READ-KEY.
   DISPLAY "RL05:(" TR-FS "):(00):RELATIVE RANDOM READ FILE STATUS".
   DISPLAY "RL06:(" WS-TR-KEY "):(" WS-TEST-REC-KEY "):RELATIVE FILE RANDOM READ KEY".
   PERFORM 9100-READ-NEXT.
   DISPLAY "RL08:(" TR-FS "):(00):RELATIVE SEQUENTIAL READ NEXT FILE STATUS".
   DISPLAY "RL09:(" WS-TR-KEY "):(" WS-TEST-REC-KEY "):RELATIVE FILE SEQUENTIAL READ".

   MOVE 13 TO WS-TR-KEY.
   PERFORM 9000-READ-KEY.
   DISPLAY "RL05:(" TR-FS "):(00):RELATIVE RANDOM READ FILE STATUS".
   DISPLAY "RL06:(" WS-TR-KEY "):(" WS-TEST-REC-KEY "):RELATIVE FILE RANDOM READ KEY".
   PERFORM 9100-READ-NEXT.
   DISPLAY "RL08:(" TR-FS "):(00):RELATIVE SEQUENTIAL READ NEXT FILE STATUS".
   DISPLAY "RL09:(" WS-TR-KEY "):(" WS-TEST-REC-KEY "):RELATIVE FILE SEQUENTIAL READ".

   MOVE 14 TO WS-TR-KEY.
   PERFORM 9000-READ-KEY.
   DISPLAY "RL05:(" TR-FS "):(23):RELATIVE RANDOM READ FILE STATUS INVALID KEY".
*>   DISPLAY "RL06:(" WS-TR-KEY "):(" WS-TEST-REC-KEY "):RELATIVE FILE RANDOM READ KEY".

9000-READ-KEY.
   READ TEST-FILE  RECORD INTO WS-TEST-REC
*>     INVALID KEY 
*>        DISPLAY "RL05:(" TR-FS "):(23):RELATIVE RANDOM READ FILE STATUS"
*>     NOT INVALID KEY 
*>        DISPLAY "RL05:(" TR-FS "):(00):RELATIVE RANDOM READ FILE STATUS"
*>        DISPLAY "RL06:(" WS-TR-KEY "):(" WS-TEST-REC-KEY "):RELATIVE FILE RANDOM READ KEY"
*>        PERFORM 9100-READ-NEXT
   END-READ.

9100-READ-NEXT.
   READ TEST-FILE NEXT  RECORD INTO WS-TEST-REC
*>     AT END  
*>       DISPLAY "RL07:(" TR-FS "):(10):RELATIVE SEQUENTIAL READ FILE STATUS"
*>     NOT AT END  
*>       DISPLAY "RL08:(" TR-FS "):(00):RELATIVE SEQUENTIAL READ FILE STATUS"
*>       DISPLAY "RL09:(" WS-TR-KEY "):(" WS-TEST-REC-KEY "):RELATIVE FILE SEQUENTIAL READ"
   END-READ.

