IDENTIFICATION DIVISION.
PROGRAM-ID.    RELIO24.
ENVIRONMENT DIVISION.
*> Program to read relative records using RANDOM access mode.

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
  ASSIGN TO "reliotest21.dat" 
  ORGANIZATION IS RELATIVE
  ACCESS MODE  IS RANDOM
  RELATIVE KEY IS WS-TR-KEY
  FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
    LABEL RECORDS ARE STANDARD.

 01 TEST-REC-1.
   05 TR-KEY-1                 PIC X(03).
   05 FILLER                   PIC X(01).
   05 TR-DESCRIPTION-1         PIC X(09).

 01 TEST-REC-2.
   05 TR-KEY-2                 PIC X(03).
   05 FILLER                   PIC X(01).
   05 TR-DESCRIPTION-2         PIC X(19).

WORKING-STORAGE SECTION.
 01 WS-TR-KEY                  PIC 9(03).
 01 TR-FS                      PIC 9(02).

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.

   PERFORM C000-PROCESS.

   PERFORM B000-HOUSEKEEPING.

   STOP RUN.

A000-INITIALIZE.
   OPEN INPUT TEST-FILE.
   DISPLAY "RLO4:(" TR-FS "):(00):RELATIVE RANDOM INPUT OPEN STATUS".

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RLC4:(" TR-FS "):(00):RELATIVE RANDOM INPUT CLOSE STATUS".

C000-PROCESS.

   MOVE 5 TO WS-TR-KEY.
   PERFORM 9000-READ-KEY.
   DISPLAY "RL05:(" TR-FS "):(00):RELATIVE RANDOM READ FILE STATUS".
   DISPLAY "RL06:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE RANDOM READ KEY".
   DISPLAY "RL07:(" TR-DESCRIPTION-1 "):(AAAAAAAAA):RELATIVE FILE RANDOM READ DESCRIPTION".

   MOVE 13 TO WS-TR-KEY.
   PERFORM 9000-READ-KEY.
   DISPLAY "RL05:(" TR-FS "):(00):RELATIVE RANDOM READ FILE STATUS".
   DISPLAY "RL06:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE RANDOM READ KEY".
   DISPLAY "RL07:(" TR-DESCRIPTION-1 "):(CCCCCCCCC):RELATIVE FILE RANDOM READ DESCRIPTION".

   MOVE 14 TO WS-TR-KEY.
   PERFORM 9000-READ-KEY.
   DISPLAY "RL05:(" TR-FS "):(23):RELATIVE RANDOM READ FILE STATUS INVALID KEY".
*>   DISPLAY "RL06:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE RANDOM READ KEY".

9000-READ-KEY.
   READ TEST-FILE
*>     INVALID KEY 
*>        DISPLAY "RL05:(" TR-FS "):(23):RELATIVE RANDOM READ FILE STATUS"
*>     NOT INVALID KEY 
*>        DISPLAY "RL05:(" TR-FS "):(00):RELATIVE RANDOM READ FILE STATUS"
*>        DISPLAY "RL06:(" WS-TR-KEY "):(" TR-DESCRIPTION-1 "):RELATIVE FILE RANDOM READ KEY"
*>        PERFORM 9100-READ-NEXT
   END-READ.

