IDENTIFICATION DIVISION.
PROGRAM-ID.    RELIO63.
ENVIRONMENT DIVISION.
*> Program to read relative records using SEQUENTIAL access mode.

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
  ASSIGN TO "reliotest61.dat" 
  ORGANIZATION IS RELATIVE
  ACCESS MODE  IS SEQUENTIAL
  RELATIVE KEY IS WS-TR-KEY
  FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
*>     LABEL RECORD IS STANDARD
   RECORD IS VARYING 15 TO 72 CHARACTERS.

 01 TEST-REC-1.
   05 TR-KEY-1               PIC 9(03).
   05 FILLER                 PIC X(01).
   05 TR-DESCRIPTION-1       PIC X(06).
   05 TR-BIN-IDX-1           PIC 9(02).
   05 TR-BIN-NUMBER-1        PIC X(03)
      OCCURS 1 TO 20 TIMES DEPENDING ON TR-BIN-IDX-1.

WORKING-STORAGE SECTION.
 01 WS-TR-KEY                  PIC 9(03).
 01 TR-FS                      PIC 9(02).
 01 WS-EOF-IND                 PIC X(01) VALUE 'N'.
   88 WS-EOF-TRUE              VALUE 'Y'.

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.

   PERFORM 9000-READ-IT UNTIL WS-EOF-TRUE.
   PERFORM B000-HOUSEKEEPING.

   STOP RUN.

A000-INITIALIZE.
   OPEN INPUT TEST-FILE.
   DISPLAY "RLO3:(" TR-FS "):(00):RELATIVE SEQUENTIAL INPUT OPEN STATUS".

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RLC3:(" TR-FS "):(00):RELATIVE SEQUENTIAL INPUT CLOSE STATUS".

9000-READ-IT.
   MOVE '000' TO TR-KEY-1.
   READ TEST-FILE RECORD
     AT END 
       MOVE 'Y' TO WS-EOF-IND
     NOT AT END 
       DISPLAY "RL03:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE SEQUENTIAL READ"
   END-READ.

