IDENTIFICATION DIVISION.
PROGRAM-ID.    RELIO65.
ENVIRONMENT DIVISION.
*> Program to read relative records using RANDOM access mode.

CONFIGURATION SECTION. 
INPUT-OUTPUT SECTION.
FILE-CONTROL.
SELECT TEST-FILE 
  ASSIGN TO "reliotest61.dat" 
  ORGANIZATION IS RELATIVE
  ACCESS MODE  IS DYNAMIC
  RELATIVE KEY IS WS-TR-KEY
  FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
*>     LABEL RECORD IS STANDARD
   RECORD IS VARYING 15 TO 72 CHARACTERS.

 01 TEST-REC-1.
   05 TR-KEY-1               PIC 9(03).
   05 FILLER                 PIC X(01).
   05 TR-DESCRIPTION-1       PIC X(06).
   05 TR-BIN-IDX-1           PIC 9(02).
   05 TR-BIN-NUMBER-1        PIC X(03)
      OCCURS 1 TO 20 TIMES DEPENDING ON TR-BIN-IDX-1.

WORKING-STORAGE SECTION.
 01 WS-TR-KEY                  PIC 9(03).
 01 TR-FS                      PIC 9(02).

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.

   PERFORM C000-PROCESS.

   PERFORM B000-HOUSEKEEPING.

   STOP RUN.

A000-INITIALIZE.
   OPEN INPUT TEST-FILE.
   DISPLAY "RLO4:(" TR-FS "):(00):RELATIVE RANDOM INPUT OPEN STATUS".

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RLC4:(" TR-FS "):(00):RELATIVE RANDOM INPUT CLOSE STATUS".

C000-PROCESS.

   MOVE 5 TO WS-TR-KEY.
   PERFORM 9000-READ-KEY.
   DISPLAY "RL04:(" TR-FS "):(00):RELATIVE RANDOM READ FILE STATUS".
   DISPLAY "RL05:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE RANDOM READ KEY".
   DISPLAY "RL06:(" TR-DESCRIPTION-1 "):(BBBBBB):RELATIVE FILE RANDOM READ DESCRIPTION".
   DISPLAY "RL24:(" TR-BIN-IDX-1 "):(15):RELATIVE FILE READ BIN IDX".
   PERFORM 9100-READ-NEXT.
   DISPLAY "RL07:(" TR-FS "):(00):RELATIVE SEQUENTIAL READ NEXT FILE STATUS".
   DISPLAY "RL08:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE SEQUENTIAL READ".
   DISPLAY "RL09:(" TR-DESCRIPTION-1 "):(CCCCCC):RELATIVE FILE RANDOM READ DESCRIPTION".
   DISPLAY "RL24:(" TR-BIN-IDX-1 "):(05):RELATIVE FILE READ BIN IDX".

   MOVE 16 TO WS-TR-KEY.
   PERFORM 9000-READ-KEY.
   DISPLAY "RL04:(" TR-FS "):(00):RELATIVE RANDOM READ FILE STATUS".
   DISPLAY "RL05:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE RANDOM READ KEY".
   DISPLAY "RL06:(" TR-DESCRIPTION-1 "):(EEEEEE):RELATIVE FILE RANDOM READ DESCRIPTION".
   DISPLAY "RL24:(" TR-BIN-IDX-1 "):(13):RELATIVE FILE READ BIN IDX".
   PERFORM 9100-READ-PREV.
   DISPLAY "RL07:(" TR-FS "):(00):RELATIVE SEQUENTIAL READ NEXT FILE STATUS".
   DISPLAY "RL08:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE SEQUENTIAL READ".
   DISPLAY "RL09:(" TR-DESCRIPTION-1 "):(DDDDDD):RELATIVE FILE RANDOM READ DESCRIPTION".
   DISPLAY "RL24:(" TR-BIN-IDX-1 "):(18):RELATIVE FILE READ BIN IDX".

   MOVE 14 TO WS-TR-KEY.
   PERFORM 9000-READ-KEY.
   DISPLAY "RL04:(" TR-FS "):(23):RELATIVE RANDOM READ FILE STATUS INVALID KEY".
*>   DISPLAY "RL05:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE RANDOM READ KEY".

9000-READ-KEY.
   READ TEST-FILE 
*>     INVALID KEY 
*>        DISPLAY "RL05:(" TR-FS "):(23):RELATIVE RANDOM READ FILE STATUS"
*>     NOT INVALID KEY 
*>        DISPLAY "RL05:(" TR-FS "):(00):RELATIVE RANDOM READ FILE STATUS"
*>        DISPLAY "RL06:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE RANDOM READ KEY"
*>        PERFORM 9100-READ-NEXT
   END-READ.

9100-READ-NEXT.
   READ TEST-FILE NEXT  
*>     AT END  
*>       DISPLAY "RL07:(" TR-FS "):(10):RELATIVE SEQUENTIAL READ FILE STATUS"
*>     NOT AT END  
*>       DISPLAY "RL08:(" TR-FS "):(00):RELATIVE SEQUENTIAL READ FILE STATUS"
*>       DISPLAY "RL09:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE SEQUENTIAL READ"
   END-READ.

9100-READ-PREV.
   READ TEST-FILE PREVIOUS 
*>     AT END  
*>       DISPLAY "RL07:(" TR-FS "):(10):RELATIVE SEQUENTIAL READ FILE STATUS"
*>     NOT AT END  
*>       DISPLAY "RL08:(" TR-FS "):(00):RELATIVE SEQUENTIAL READ FILE STATUS"
*>       DISPLAY "RL09:(" WS-TR-KEY "):(" TR-KEY-1 "):RELATIVE FILE SEQUENTIAL READ"
   END-READ.
