IDENTIFICATION DIVISION.
PROGRAM-ID. RELIO68.
ENVIRONMENT DIVISION.

CONFIGURATION SECTION. 
SPECIAL-NAMES.
*>    DECIMAL-POINT IS COMMA.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
 SELECT TEST-FILE 
     ASSIGN TO "reliotest61.dat" 
     ORGANIZATION IS RELATIVE
     ACCESS MODE  IS SEQUENTIAL
     RECORD KEY   IS WS-TR-KEY
     FILE STATUS  IS TR-FS.

DATA DIVISION.
FILE SECTION.
FD  TEST-FILE
*>     LABEL RECORD IS STANDARD
   RECORD IS VARYING 15 TO 72 CHARACTERS.

 01 TEST-REC-1.
   05 TR-KEY-1               PIC 9(03).
   05 FILLER                 PIC X(01).
   05 TR-DESCRIPTION-1       PIC X(06).
   05 TR-BIN-IDX-1           PIC 9(02).
   05 TR-BIN-NUMBER-1        PIC X(03)
      OCCURS 1 TO 20 TIMES DEPENDING ON TR-BIN-IDX-1.

WORKING-STORAGE SECTION.
 01 TR-FS                      PIC 9(02).
 01 WS-TR-KEY                  PIC 9(03).
 01 W-COUNTER                  PIC 9(15).
 01 W01-SWITCHES               PIC X(03).
   88 W01-END VALUE "YES".
   88 W01-MORE VALUE "NO".

PROCEDURE DIVISION.
0000-PROGRAM-ENTRY.
   PERFORM A000-INITIALIZE.
   PERFORM 0000-LOOP.
   PERFORM B000-HOUSEKEEPING.

   STOP RUN.

0000-LOOP.
   PERFORM D000-READ.
   PERFORM C000-PROCESS THRU C000-EXIT UNTIL W01-END.

A000-INITIALIZE.
   OPEN I-O TEST-FILE.
   DISPLAY "RLO2:(" TR-FS "):(00):RELATIVE READ OPEN".
   MOVE "NO" TO W01-SWITCHES.
   MOVE 0 TO W-COUNTER.

B000-HOUSEKEEPING.
   CLOSE TEST-FILE.
   DISPLAY "RLC2:(" TR-FS "):(00):RELATIVE READ CLOSE".

C000-PROCESS.

   IF WS-TR-KEY = 3
   THEN
     DISPLAY "RL21:(" TR-FS "):(00):RELATIVE FILE READ STATUS" 
     DISPLAY "RL22:(" TR-KEY-1 "):(003):RELATIVE FILE READ KEY"
     DISPLAY "RL24:(" TR-BIN-IDX-1 "):(05):RELATIVE FILE READ BIN IDX"
     MOVE ALL "R" TO TR-DESCRIPTION-1
     REWRITE TEST-REC-1
     DISPLAY "RR03:(" TR-FS "):(00):RELATIVE REWRITE STATUS"
   END-IF.

   IF WS-TR-KEY = 16
   THEN
     DISPLAY "RL21:(" TR-FS "):(00):RELATIVE FILE READ STATUS" 
     DISPLAY "RL22:(" TR-KEY-1 "):(016):RELATIVE FILE READ KEY"
     DISPLAY "RL24:(" TR-BIN-IDX-1 "):(13):RELATIVE FILE READ BIN IDX"
     MOVE ALL "R" TO TR-DESCRIPTION-1
     REWRITE TEST-REC-1
     DISPLAY "RR03:(" TR-FS "):(00):RELATIVE REWRITE STATUS"
   END-IF.

   PERFORM D000-READ.

C000-EXIT.
   EXIT.

D000-READ.

   READ TEST-FILE NEXT
    AT END
      DISPLAY "RL10:(" TR-FS "):(10):INDEX FILE READ AT EOF"
      MOVE "YES" TO W01-SWITCHES
   END-READ.
