 IDENTIFICATION DIVISION.
 PROGRAM-ID.    SEQIO19.
 ENVIRONMENT DIVISION.

 CONFIGURATION SECTION. 
 SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
 INPUT-OUTPUT SECTION.
 FILE-CONTROL.
  SELECT GOZOUT ASSIGN TO "seqdata19.dat" 
         ORGANIZATION IS SEQUENTIAL 
         ACCESS       IS SEQUENTIAL
         FILE STATUS  IS FS.

 DATA DIVISION.
 FILE SECTION.

 FD  GOZOUT
*>     LABEL RECORD IS STANDARD
*>    RECORD CONTAINS 18 TO 75 CHARACTERS
     RECORD IS VARYING 18 TO 75 CHARACTERS.
 01 GOZOUT-REC-1.
     03 X-IND-1                      PIC  9(03).
     03 DESCRIPTION-1                PIC  X(10).
     03 BIN-IDX-1                    PIC  9(02).
     03 BIN-NUMBER-1                 PIC  X(03)
        OCCURS 1 TO 20 TIMES DEPENDING ON BIN-IDX-1.

 WORKING-STORAGE SECTION.
 01 FS                               PIC  9(02).
 01 IDX                              PIC  9(02).
 01 WS-COUNTERS.
     05 WS-TEST-COUNTER              PIC  9(4).

 PROCEDURE DIVISION.
 0000-PROGRAM-ENTRY.
      MOVE 0              TO WS-TEST-COUNTER.
      PERFORM B000-INITIALIZE THRU B000-EXIT.
      PERFORM C000-MAIN-LOGIC THRU C000-EXIT.
      PERFORM D000-CLEANUP THRU D000-EXIT.
      PERFORM E000-SUMMARY THRU E000-EXIT.
      STOP RUN.
      
      DISPLAY "SQ06:(IL):(FA):PROGRAM RAN PAST STOP RUN".

 0000-EXIT.
      EXIT.
 
 B000-INITIALIZE.
      OPEN OUTPUT GOZOUT.
      ADD 1             TO WS-TEST-COUNTER.
      DISPLAY "SO15:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT OPEN STATUS".
      PERFORM B020-INITIALIZE VARYING IDX 
          FROM 1 BY 1 UNTIL IDX EQUAL 20.
 B000-EXIT.
      EXIT.

 B020-INITIALIZE.
      MOVE IDX TO BIN-NUMBER-1 (IDX).
 B020-EXIT.
      EXIT.

 C000-MAIN-LOGIC.
*>      MOVE SPACES TO GOZOUT-REC-1.

      MOVE 001 TO X-IND-1.
      MOVE ALL 'A' TO DESCRIPTION-1.
      MOVE 1 TO BIN-IDX-1.
      WRITE GOZOUT-REC-1.
      DISPLAY "SW15:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT WRITE STATUS".

      ADD 1             TO WS-TEST-COUNTER.

      MOVE 002 TO X-IND-1.
      MOVE ALL 'B' TO DESCRIPTION-1.
      MOVE 3 TO BIN-IDX-1.
      WRITE GOZOUT-REC-1.
      DISPLAY "SW15:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT WRITE STATUS".

      ADD 1             TO WS-TEST-COUNTER.

      MOVE 003 TO X-IND-1.
      MOVE ALL 'C' TO DESCRIPTION-1.
      MOVE 5 TO BIN-IDX-1.
      WRITE GOZOUT-REC-1.
      DISPLAY "SW15:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT WRITE STATUS".

      ADD 1             TO WS-TEST-COUNTER.

      MOVE 004 TO X-IND-1.
      MOVE ALL 'D' TO DESCRIPTION-1.
      MOVE 11 TO BIN-IDX-1.
      WRITE GOZOUT-REC-1.
      DISPLAY "SW15:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT WRITE STATUS".

      ADD 1             TO WS-TEST-COUNTER.

 C000-EXIT.
      EXIT.

 D000-CLEANUP.
      CLOSE GOZOUT.
      DISPLAY "SC15:(" FS "):(00):"
          "SEQUENTIAL VARIABLE OUTPUT CLOSE STATUS".
      ADD 1             TO WS-TEST-COUNTER.
 D000-EXIT.
      EXIT.
 
 E000-SUMMARY.
      DISPLAY "SQ04:(" WS-TEST-COUNTER "):(0006):"
          "TEST COUNT VALIDATION".
 E000-EXIT.
      EXIT. 
