 IDENTIFICATION DIVISION.
 PROGRAM-ID.    SEQIO22.
 ENVIRONMENT DIVISION.

 CONFIGURATION SECTION. 
 SPECIAL-NAMES.
*>     DECIMAL-POINT IS COMMA.
 INPUT-OUTPUT SECTION.
 FILE-CONTROL.
     SELECT GOZINOUT ASSIGN TO "seqdata19.dat" 
            ORGANIZATION IS SEQUENTIAL 
            ACCESS MODE     SEQUENTIAL
            FILE STATUS  IS FS.

 DATA DIVISION.
 FILE SECTION.

 FD  GOZINOUT
*>     LABEL RECORD IS STANDARD
*>    RECORD CONTAINS 18 TO 75 CHARACTERS
     RECORD IS VARYING 18 TO 75 CHARACTERS.
 01 GOZINOUT-REC-1.
     03 X-IND-1                      PIC  9(03).
     03 DESCRIPTION-1                PIC  X(10).
     03 BIN-IDX-1                    PIC  9(02).
     03 BIN-NUMBER-1                 PIC  X(03)
        OCCURS 1 TO 20 TIMES DEPENDING ON BIN-IDX-1.
      
 WORKING-STORAGE SECTION.
 01 FS                               PIC  9(02).
 01 IDX                              PIC  9(02).
 01 WS-COUNTERS.
     05 WS-TEST-COUNTER              PIC  9(4).

 PROCEDURE DIVISION.
 0000-PROGRAM-ENTRY.
      PERFORM B000-INITIALIZE THRU B000-EXIT.
      PERFORM C000-MAIN-LOGIC THRU C000-EXIT.
      PERFORM D000-CLEANUP THRU D000-EXIT.
      STOP RUN.

 B000-INITIALIZE.
      OPEN I-O GOZINOUT.
      DISPLAY "SO17:(" FS "):(00):"
          "SEQUENTIAL VARIABLE I-O OPEN STATUS".
 B000-EXIT.
     EXIT.

 C000-MAIN-LOGIC.
      READ GOZINOUT.
      DISPLAY "SR02:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT READ STATUS".
      DISPLAY "SR03:(" X-IND-1 "):(001):"
          "DATA FROM READ".
      DISPLAY "SR03:(" DESCRIPTION-1 "):(AAAAAAAAAA):"
          "DATA FROM READ".
      DISPLAY "SR03:(" BIN-IDX-1 "):(01):"
          "BIN IDX FROM READ".

      MOVE 999 TO X-IND-1.
      MOVE ALL 'Z' TO DESCRIPTION-1.
      REWRITE GOZINOUT-REC-1.
      DISPLAY "SR04:(" FS "):(00):"
          "SEQUENTIAL VARIABLE I/O REWRITE STATUS".
      
      READ GOZINOUT.
      DISPLAY "SR02:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT STATUS".
      DISPLAY "SR03:(" X-IND-1 "):(002):"
          "DATA FROM READ".
      DISPLAY "SR03:(" DESCRIPTION-1 "):(BBBBBBBBBB):"
          "DATA FROM READ".
      DISPLAY "SR03:(" BIN-IDX-1 "):(03):"
          "BIN IDX FROM READ".

      READ GOZINOUT.
      DISPLAY "SR02:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT STATUS".
      DISPLAY "SR03:(" X-IND-1 "):(003):"
          "DATA FROM READ".
      DISPLAY "SR03:(" DESCRIPTION-1 "):(CCCCCCCCCC):"
          "DATA FROM READ".
      DISPLAY "SR03:(" BIN-IDX-1 "):(05):"
          "BIN IDX FROM READ".

      READ GOZINOUT.
      DISPLAY "SR02:(" FS "):(00):"
          "SEQUENTIAL VARIABLE INPUT STATUS".
      DISPLAY "SR03:(" X-IND-1 "):(004):"
          "DATA FROM READ".
      DISPLAY "SR03:(" DESCRIPTION-1 "):(DDDDDDDDDD):"
          "DATA FROM READ".
      DISPLAY "SR03:(" BIN-IDX-1 "):(11):"
          "BIN IDX FROM READ".

 C000-EXIT.
      EXIT.

 D000-CLEANUP.
      CLOSE GOZINOUT.
      DISPLAY "SC17:(" FS "):(00):"
          "SEQUENTIAL VARIABLE I-O CLOSE STATUS".

 D000-EXIT.
     EXIT.  
